<?php

/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005/2006 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */

// get required classes
if (file_exists('./require.php')) {
	require_once ('./require.php');
} else {
	die ('Fatal error loading CMS. Please contact webmaster.');
}

// make object
$cnCore = new cnCore();

// get/set language
$setLang= (empty ($_GET['lang'])) ? $cnCore->getBackendLanguage() : $_GET['lang'];

// define language
include_once ('./language/'.$setLang.'.language.php');
$lang= $cnLanguageArray[$setLang];

// get url params
$getPath= empty ($_GET['path']) ? '' : $_GET['path'];
$getIdentifier= empty ($_GET['cid']) ? '' : $_GET['cid'];
$getFolder= empty ($_GET['folder']) ? '' : $_GET['folder'];
$getFile= empty ($_GET['file']) ? '' : $_GET['file'];
$getType= empty ($_GET['type']) ? 'file' : $_GET['type'];
$getSingle= empty ($_GET['single']) ? 'false' : $_GET['single'];

// fix ending backslash in folder path
if (substr($getFolder, (strlen($getFolder) - 1)) == '/')
	$getCorrectedFolder= substr($getFolder, 0, (strlen($getFolder) - 1));

// define path, check '/'s
$path= $_SERVER['DOCUMENT_ROOT'];
if (substr($path, (strlen($path) - 1)) == '/')
	$path= substr($path, 0, (strlen($path) - 1));

// define absolute path
$absolute_path= $path.$getPath.$getFolder;

if (file_exists($absolute_path.$getFile)) {

	if ($_POST['generate']) {
		$contentFile= $_POST['resultArea'];
		$contentFile= stripslashes($contentFile);
		$open= fopen($absolute_path.$getFile, "w+");
		fwrite($open, $contentFile);
		fclose($open);
	}

	$file= file($absolute_path.$getFile);
	
	foreach ($file as $fileContent) {
		$_lines .= htmlspecialchars($fileContent);
	}

	$backButton= '<input type="button" onclick="changeUrl(\'./upload.php?path='.$getPath.'&folder='.$getCorrectedFolder.'&cid='.$getIdentifier.'&type='.$getType.'&single='.$getSingle.'\');" value="'.$lang['button_back'].'" class="submit_120">
	';

	$content= '
			<li class="item">
				<div class="row">
						<textarea style="width:98%;height:24em;font-family:\'Courier New\',Courier,mono;font-size:12px" name="resultArea">'.$_lines.'</textarea>
				</div>
			</li>
			<li class="item">
				<div class="row">
					<input type="submit" class="submit_120" name="generate" value="'.$lang['button_save'].'">'.$backButton.'
				</div>
			</li>';

} else {
	// no readable dir in $absolute_path
	$content= '<li class="item"><div class="row">Error (path: '.$absolute_path.')</div>'.$backButton.'</li>';
}

$displayObj= '
		<p class="head">DATEI '.$getFile.'</p>
		<form action="'.$_SERVER['PHP_SELF'].'?path='.$getPath.'&cid='.$getIdentifier.'&type='.$getType.'&single='.$getSingle.'&folder='.$getFolder.'&file='.$getFile.'&lang='.$setLang.'" method="post"> 
			<ul>
			'.$content.'
			</ul>
		</form>
		';

// Init smarty
$smarty= new Smarty();
$smarty->template_dir= CN_SKINDIR;
$smarty->compile_dir= 'smarty/templates_cn';
$smarty->cache_dir= 'smarty/cache';
$smarty->config_dir= 'smarty/configs';

$smarty->assign('cnSkinDir', CN_SKINDIR);

$smarty->assign('contentDisplay', $displayObj);
$displayUpload= $smarty->fetch('_upload.html');
$smarty->assign('content', $displayUpload);

$smarty->display('_page_upload.html');
?>