<?php

/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005/2006 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */


include ('../adodb/adodb.inc.php');

include('../library/configure.local.php');
$newVersion = CN_VERSION;

if (!file_exists('../../upload/configure.tmp')) die ('<span style="font:13px sans-serif;">Config file missing. Please read update note.</span>');

include('../../upload/configure.tmp');
$oldVersion = CN_VERSION_FOR_UPDATE; 

// new admin user
$cn_adminuser= CN_ADMIN_USER;
$cn_adminpass= CN_ADMIN_PASS;
$cn_adminname= CN_WEBMASTER_NAME;
$cn_adminemail= CN_WEBMASTER_EMAIL;

// local config
$cn_dbuser= CN_DB_USER;
$cn_dbname= CN_DB_NAME;
$cn_dbpassword= CN_DB_PASSWORD;
$cn_dbhost= CN_DB_HOST;

$cn_config= CN_TBL_CONFIG;
$cn_content= CN_TBL_CONTENT;
$cn_sections= CN_TBL_SECTIONS;
$cn_sections_seq= CN_TBL_SECTIONS."_seq";
$cn_modul= CN_TBL_MODUL;
$cn_sessions= CN_TBL_SESSIONS;

$rootPath= $_SERVER['DOCUMENT_ROOT'];
if (substr($rootPath, (strlen($rootPath) - 1)) == '/')
	$rootPath= substr($rootPath, 0, (strlen($rootPath) - 1));

$confDir = str_replace('install','',$rootPath.CN_ROOTDIR.'library/');
$confFile = $confDir.'configure.php';
$confLocalFile = $confDir.'configure.local.php';
$destPath = str_replace('cn/library/','upload/configure.tmp',$confDir);
$rootDir = str_replace('cn/library/','',$confDir);

// make db connection
$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
$cnDatabase->Connect($cn_dbhost, $cn_dbuser, $cn_dbpassword, $cn_dbname);
$dbErrorMsg =$cnDatabase->ErrorMsg();
if ($dbErrorMsg!='') die ('<span style="font:13px sans-serif;">Cannot connect to database. Please check configure.tmp file in uplaod/</span>');

// check table fields
function checkColumns($tableName,$tableString,$cnDatabase) {
	$res = $cnDatabase->Execute('SHOW COLUMNS FROM '.$tableName);
	while ($row = $res->FetchRow()) {
		$columns[] = $row['Field'];
	}
	if (in_array($tableString,$columns)) {
		return false;
	} else {
		return true;
	}
}

// define tables
$table= array ();

// Version checking
$explodeOldRC = explode('RC',$oldVersion);
$explodeOld = explode ('.',$explodeOldRC[0]);
$first = intval($explodeOld[0]);
$second = intval($explodeOld[1]);

// Version below 1.19
if ($first == 1 && $second <= 19) {
	$table[]= "ALTER TABLE `$cn_config` CHANGE `teasercontentpageid` `teasercontentpageid` VARCHAR(255) NOT NULL DEFAULT '0';";
	$table[]= "UPDATE `$cn_config` SET frontendlanguage = 'en';";
	$table[]= "UPDATE `$cn_content` SET endtime = 1893495600;";
}

// Version below 1.25
if ( $first == 1 && $second <= 25) {
	if ( checkColumns($cn_sessions,'contentlanguage',$cnDatabase) ) 
		$table[]= "ALTER TABLE `$cn_sessions` ADD `contentlanguage` VARCHAR(255) NOT NULL DEFAULT '';";
	if ( checkColumns($cn_sessions,'backendlanguage',$cnDatabase) )		
		$table[]= "ALTER TABLE `$cn_sessions` ADD `backendlanguage` VARCHAR(255) NOT NULL DEFAULT '';";
	$table[]= "UPDATE `$cn_content` SET endtime = 1893495600;";	
	$table[]= "UPDATE `$cn_config` SET frontendlanguage = 'default';";
	$table[]= "UPDATE `$cn_config` SET backendlanguage = 'en';";
	$table[]= "UPDATE `$cn_sessions` SET backendlanguage = 'en';";
	$table[]= "ALTER TABLE `$cn_modul` CHANGE `paramvalue` `paramvalue` TEXT NOT NULL;";	
}

// Version below 1.30
if ( $first == 1 && $second <= 30) {
	// add md5 value
	$sql = "SELECT * FROM `$cn_sessions` WHERE id = 1";
	$res = $cnDatabase->Execute($sql);
	$row = $res->FetchRow();
	$table[]= "UPDATE `$cn_sessions` SET password = '".md5($row['password'])."';";	
	// change table fields
	if ( checkColumns($cn_config,'metainfo',$cnDatabase) ) 
		$table[]= "ALTER TABLE `$cn_config` CHANGE `metainfo` `metainfo` text NOT NULL;";	
	if ( checkColumns($cn_config,'metadescription',$cnDatabase) ) 
		$table[]= "ALTER TABLE `$cn_config` CHANGE `metadescription` `metadescription` text NOT NULL;";	
	if ( checkColumns($cn_config,'metakeywords',$cnDatabase) ) 
		$table[]= "ALTER TABLE `$cn_config` CHANGE `metakeywords` `metakeywords` text NOT NULL;";	
}

switch ($_POST['installStep']) {

	default :
		if ($_POST['login'] != '' && md5($_POST['login']) == '54c84b40e9ff5a31472904a0cd2f0a17') {
			$installStep= 1;
			$installHeadline= 'Welcome';
			$installMsg='<p>Welcome to the update tool of contentNow.</p>';
			$installSubmit= '<input type="submit" class="submit_120" name="installSubmit" value="Start Update">';
		} else {
			if (!is_writable($confDir)) die ('<span style="font:13px sans-serif;">Please make config directory writable: '.$confDir.'</span>');
			$installHeadline= 'Update Login';
			$installMsg= '<input type="password" name="login" id="installpassword" class="width_120" value="">&nbsp;&nbsp;Please enter install password ...';
			$installSubmit= '<input type="submit" class="submit_120" name="installSubmit" value="Login">
						<script type="text/javascript">window.onload = document.getElementById(\'installpassword\').focus();</script>';
		}
		break;

	case "1" :
		$installStep= 2;
		$installHeadline= 'Update overview';
		$installMsg= '<p>Step 1: Update MySQL tables</p>
					 <p>Step 2: Checking writable directories</p>
					 <p>Step 3: Finish installation</p>';
		$installSubmit= '<input type="submit" class="submit_120" name="installSubmit" value="Start Install">';
		break;

	case "2" :
		$installStep= 3;
		
		foreach ($table as $id => $value) {
		$res = $cnDatabase->Execute($value);
			if ($res == false) die ('<span style="font:13px sans-serif;">Table creation failed. Check your database configuration in ./cn/library/configure.php<br><br>'.$value.'<br><br>'.mysql_error().'</span>');
		}
		
		// Modify configure.php
		$localConfContent.= "\n";
		$localConfContent.= "define('CN_DB_USER','$cn_dbuser');\n";
		$localConfContent.= "define('CN_DB_NAME','$cn_dbname');\n";
		$localConfContent.= "define('CN_DB_PASSWORD','$cn_dbpassword');\n";
		$localConfContent.= "define('CN_DB_HOST','$cn_dbhost');\n";
		$localConfContent.= "define('CN_VERSION_FOR_UPDATE','".$newVersion."');\n";
		$localConfContent.= "?>\n";
		
		// read old file
		$handle = fopen ($confLocalFile, "r");
		$contents = fread ($handle, filesize ($confLocalFile));
		fclose ($handle);
		$contents = str_replace("?>", "// Modified by install tool", $contents);
		
		if (!$handle = fopen($confFile, "w+")) die ('<span style="font:13px sans-serif;">Unable to locate local config.</span>');
		if (!fwrite($handle, $contents.$localConfContent)) die ('<span style="font:13px sans-serif;">Unable to write local config.</span>');		
		
		$installHeadline= 'Installation Step 1 | MySQL';
		$installMsg= '<p><strong>Step 1: Update MySQL tables | done</strong></p>
					 <p>Step 2: Checking writable directories</p>
					 <p>Step 3: Finish installation</p>';
		$installSubmit= '<input type="submit" class="submit_120" name="installSubmit" value="Next">';
		break;

	case "3" :
		$installHeadline= 'Installation Step 2 | Checking folders';

		$filename[]= 'cn/smarty/templates_c';
		$filename[]= 'cn/smarty/templates_cn';
		$filename[]= 'cn/smarty/cache';
		$filename[]= 'upload';
		$filename[]= 'upload_c';
		$filename[]= 'upload/file';
		$filename[]= 'upload/flash';
		$filename[]= 'upload/image';
		$filename[]= 'upload/upload_admin';
		$filename[]= 'cn/constants.php';

		$filenameNotWritable= array ();
		$filenameWritable= array ();

		foreach ($filename as $value) {
			if (is_writable($rootDir.$value)) {
				$filenameWritable[]= $value;
			} else {
				$filenameNotWritable[]= $value;
			}
		}

		if (count($filenameNotWritable) == 0) {
			$installStep= 4;
			$installMsg= '<p><strong>Step 1: Update MySQL tables | done</strong></p>
										 <p><strong>Step 2: Checking writable directories | done</strong></p>
										 <p>Step 3: Finish installation</p>';
			$installSubmit= '<input type="submit" class="submit_120" name="installSubmit" value="Next">';
		} else {
			$folder_writable= '';
			$folder_not_writable= '';
			foreach ($filenameWritable as $value) {
				$folder_writable .= $value.' (ok)<br>';
			}
			foreach ($filenameNotWritable as $value) {
				$folder_not_writable .= $value.' (folder not writable)<br>';
			}
			$installStep= 3;
			$installMsg= '<p><strong>Step 1: Update MySQL tables | ok</strong>/</p>
										 <p>Step 2: Checking writable directories | Error</p>
										 <p style="margin: 10px;"></p>
										 <p>'.$folder_writable.'<p style="margin: 10px;"></p><hr><p style="margin: 10px;"></p>'.$folder_not_writable.'<p style="margin: 10px;"></p>
										 <p>Step 3: Finish installation</p>';
			$installSubmit= '<input type="submit" class="submit_120" name="installSubmit" value="Check again">';
		}
		break;

	case "4" :

		if (file_exists($destPath)) if(!@unlink($destPath)) die ('<span style="font:13px sans-serif;">Unable to delete local config.</span>');
		if (!@copy($confFile, $destPath)) die ('<span style="font:13px sans-serif;">Unable to move local config.</span>');	
	
		$installHeadline= 'Installation Step 3 | Login Backend';
		$installMsg= '<p><strong>Step 1: Update MySQL tables | done</strong></p>
							 <p><strong>Step 2: Checking writable directories | done</strong></p>
							 <p><strong>Step 3: Finish installation | done</strong></p>';
		$installSubmit= '<input type="button" onclick="window.location.href=\'../index.php\'" class="submit_120" name="installSubmit" value="Login contentNow">';
		break;
}

echo '
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="de_DE" xml:lang="de_DE">
<!--
 * ContentNow | Small Content Management System
 * File: install update.php
 * Created: 10.02.2006
 * (C) 2006 Andre Michaelis <kontakt(at)michaelis-freunde.de>
-->
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
	<title>ContentNow Install</title>
	<link href="../'.CN_SKINDIR.'style.css" rel="stylesheet" type="text/css" media="screen" />
</head>
<body>
<form method="POST" action="'.$_SERVER['SELF'].'" name="cnInstall" id="cnInstall">
<input type="hidden" name="installStep" value="'.$installStep.'">
<div id="cn_topnav"><div id="cn_topnavinline"><div id="row">&nbsp;</div></div></div>
<div id="cn_login">
<p class="head">'.$installHeadline.'</p>
<ul>
	<li class="item">'.$installMsg.'</li>
  	<li class="item">'.$installSubmit.'</li>
   	 </ul>
   	 </div>
   	 </form>
</body>
</html>';

?>



