<?php

/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005/2006 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */

 class cnCore {
 	
	var $pageid;
	var $mode;
	var $contentLanguage;
	var $contentLanguageSuffix;
	var $language;
	var $configArray;
	var $contentArray;
	var $teaserContentArray;
	var $navigationArray;
	var $pageleft;
	var $pageright;
	var $pagelevel;
	var $pagename;
	var $pageimage;
	var $template;
	var $mtemplate;
	var $description;
	var $syskey;
	var $pagetype;
	var $pageurl;

	/**
	 * function 	setBackendLanguage() 
	 * @descr 	set backend language
	 * @param 	$setLang
	 * @return 	-
	 */	
	
	function setBackendLanguage($setLang) {
		include_once ('./language/'.$setLang.'.language.php');
		// checking if language is available
		if (empty($cnLanguageArray)) {
			$setLang = $this->getBackendLanguage();
			include_once ('./language/'.$setLang.'.language.php');
			$this->lang= $cnLanguageArray[$setLang];
			setlocale(LC_ALL, $this->lang['local_key']);
			return('Error loading language! Using default language.' );
		}
		$this->lang= $cnLanguageArray[$setLang];
		setlocale(LC_ALL, $this->lang['local_key']);
	}

	/**
	 * function 	setContentLanguage()
	 * @descr 	set frontend language
	 * @param 	$setContentLanguage
	 * @return 	-
	 */
	
	function setContentLanguage($setContentLanguage) {
		$this->contentLanguage = $setContentLanguage; 
		$this->contentLanguageSuffix = empty($setContentLanguage) ? '' : '_'.$setContentLanguage; 
	}
	
	function setId($id) {
		$this->pageid= $id;
	}
	function getId() {
		return $this->pageid;
	}
	function setMode($mode) {
		$this->mode= $mode;
	}
	function setConfigArray($array) {
		$this->configArray= $array;
	}
	function setNavigationArray($array) {
		$this->navigationArray= $array;
	}
	function setContentArray($array) {
		$this->contentArray= $array;
	}
	function setPageInfoArray($array) {
		$this->pageleft= $array['pageleft'];
		$this->pageright= $array['pageright'];
		$this->pagelevel= $array['pagelevel'];
		$this->pagename= $array['pagename'];
		$this->pageimage= $array['pageimage'];
		$this->template= $array['template'];
		$this->mtemplate= $array['mtemplate'];
		$this->description= $array['description'];
		$this->syskey= $array['syskey'];
		$this->pagetype= $array['pagetype'];
		$this->pageurl= $array['pageurl'];
	}

	/**
	 * function 	showTopNavigation()
	 * @descr	Show Head Navigation
	 * @param	-
	 * @return	string
	 */
	 
	function showTopNavigation() {
		
		$linkPageClass = ($this->mode == 'content' || $this->mode == 'meta' || $this->mode == 'list') ? 'active' : '';
		$linkPageMode = ($this->mode == 'user' || $this->mode == 'modul' || $this->mode == 'config') ? 'content' : $this->mode;
		
		if ($this->checkAccess('content'))
			$linkPage= $this->makeCNLink($this->lang['link_page'], $_SERVER['PHP_SELF'], $linkPageMode, $this->pageid, $linkPageClass);
		
		if ($this->checkAccess('meta'))
			$linkPage= $this->makeCNLink($this->lang['link_page'], $_SERVER['PHP_SELF'], $linkPageMode, $this->pageid, $linkPageClass);
		
		if ($this->checkAccess('list'))
			$linkPage= $this->makeCNLink($this->lang['link_page'], $_SERVER['PHP_SELF'], $linkPageMode, $this->pageid, $linkPageClass);

		if ($this->checkAccess('user'))
			if ($this->mode == 'user') { 
				$linkUser= $this->makeCNLink($this->lang['link_user'], $_SERVER['PHP_SELF'], 'user', $this->pageid, 'active');
			} else {
				$linkUser= $this->makeCNLink($this->lang['link_user'], $_SERVER['PHP_SELF'], 'user', $this->pageid);
			}

		if ($this->checkAccess('modul'))		
			if ($this->mode == 'modul') {
				$linkModul= $this->makeCNLink($this->lang['link_moduls'], $_SERVER['PHP_SELF'], 'modul', $this->pageid, 'active');
			} else {
				$linkModul= $this->makeCNLink($this->lang['link_moduls'], $_SERVER['PHP_SELF'], 'modul', $this->pageid);
			}			

		if ($this->checkAccess('config'))	
			if ($this->mode == 'config') {
				$linkConfig= $this->makeCNLink($this->lang['link_config'], $_SERVER['PHP_SELF'], 'config', $this->pageid, 'active');
			} else {
				$linkConfig= $this->makeCNLink($this->lang['link_config'], $_SERVER['PHP_SELF'], 'config', $this->pageid);
			}
		
		if ($this->checkAccess('filemanager'))	
			$fileManager= '<a href="#" onmouseover="window.status=\'contentnow\';return true;" onclick="SC_show(\''.$this->lang['label_filemanager'].'\', \'./upload.php?path='.CN_UPLOAD_BASEDIR.'&type=upload&lang='.$this->lang['language_key'].'\', 400, 800)">'.$this->lang['link_filemanager'].'</a>';
		
		if ($this->checkAccess('preview'))	
			$linkPreview= '<a href="#" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();openPreviewWindow(\'../index.php?inline='.$this->configArray[0]['inlineedit'].'&pageid='.$this->pageid.'&clang='.$this->contentLanguage.'\');" title="'.$this->lang['link_preview'].'">'.$this->lang['link_preview'].'</a>';
		
		$linkLogOut= $this->makeCNLink($this->lang['link_logout'].' '.strtoupper($_SESSION['user']), 'logout.php', $this->mode, $this->pageid);
		
		return '<div class="row"><div id="row_nav">'.$linkPage.$linkPreview.$fileManager.$linkUser.$linkConfig.$linkModul.$linkLogOut.'</div></div>';
	}

	/**
	 * function showContentNav()
	 * @descr	Show Content Navigation
	 * @param	-
	 * @return	string
	 */
	 
	function showContentNav() {

		$liContentClass= $this->mode == 'content' ? ' id="active"' : '';
		$linkContent= $this->makeCNLink($this->lang['link_content'], $_SERVER['PHP_SELF'], 'content', $this->pageid);

		$liContentListClass= $this->mode == 'list' ? ' id="active"' : '';
		$linkContentList= $this->makeCNLink($this->lang['link_contentlist'], $_SERVER['PHP_SELF'], 'list', $this->pageid);

		$liMetaClass= $this->mode == 'meta' ? ' id="active"' : '';
		$linkMeta= $this->makeCNLink($this->lang['link_meta'], $_SERVER['PHP_SELF'], 'meta', $this->pageid);
		
		$content = '<ul>';
		if ($this->checkAccess('meta'))
		$content .='<li'.$liMetaClass.'>'.$linkMeta.'</li>';
		if ($this->checkAccess('content'))
		$content .='<li'.$liContentClass.'>'.$linkContent.'</li>';
		if ($this->checkAccess('list'))
		$content .='<li'.$liContentListClass.'>'.$linkContentList.'</li>';
		
		$content .='<li id="end">&nbsp;</li></ul>';
		
		return $content;
	}

	/**
	 * function showNavigation()
	 * @descr	Show Navigation tree
	 * @param	-
	 * @return	string
	 */
	 
	function showNavigation() {
		
		$content= '';
		$openNode= 1;
		
		foreach ($this->navigationArray as $id => $value) {

			// check open Node
			if ($value['pageid'] == $this->pageid) $openNode= $id;

			// dont add root node
			if ($id != 0) {
				// prepare
				$content .= 'd.add('.$id.',';
				$mode = $this->mode == 'list' ? 'meta' : $this->mode;
				// loop back to get node id
				for ($i= $id -1; $i >= 0; $i --) {
					if ($this->navigationArray[$i]['pagelevel'] == ($value['pagelevel'] - 1)) {
						$content .= $i.',\''.addslashes($this->encodeStr(substr($value['pagename'.$this->contentLanguageSuffix], 0, 30))).'\',\''.$this->makeCNurl($_SERVER['PHP_SELF'], $mode, $value['pageid']).'\',\'\',\'\',\''.$this->checkPageType($value['pagetype']).'\');
						';
						break;
					}
				}
			}
		}

		// return string
		return '
			<p class="head">'.$this->lang['label_menu'].'</p>
			<div id="dtree_navigation">
			<script type="text/javascript">
				<!--
					d = new dTree(\'d\');
					d.add(0,-1,\''.addslashes($this->encodeStr(substr($this->navigationArray[0]['pagename'], 0, 30))).'\',\''.$this->makeCNurl($_SERVER['PHP_SELF'], 'config', $this->pageid).'\');
					'.$content.'
					document.write(d);
					d.openTo('.$openNode.', true);
				//-->
			</script>
			</div>
			'.$this->contentLanguageDropDown('langid',$this->contentLanguage);

	}

	/**
	 * function showContent()
	 * @descr	Show Content Elements
	 * @param	$_GET['cid'] 
	 * 			main function handling content forms
	 * 			'edit'		edit single content
	 * 			'delete' 	delete single element
	 * 			'editnew'	edit new content element
	 * 			'new'		new content
	 * 			'modul'		new modul
	 * 			'default'	list elements
	 * @return	string
	 */
	 
	function showContent() {

		// edit single content element
		if ($_GET['action'] == 'edit') {
			// get content
			$this->setContentArray(cnEngine :: getSingleContent($_GET['cid']));
			$noList= true;
			$content= '<ul id="editIcons">'.$this->getContentEditForm().'</ul>';
		}

		// delete single content element
		if ($_GET['action'] == 'delete') {
			$this->setDeleteItem($_GET['cid']);
		}

		// edit new content element
		if ($_GET['action'] == 'editnew') {
			// get content
			$this->setContentArray(cnEngine :: getSingleContent($_GET['cid']));
			$noList= true;
			$content= '<ul id="editIcons">'.$this->getContentEditForm().'</ul>';
		}

		// new content element
		if ($_GET['action'] == 'new') {
			$noList= true;
			$content= '<ul id="editIcons">'.$this->getNewContentForm().'</ul>';
		}

		// new modul element
		if ($_GET['action'] == 'modul') {
			$noList= true;
			$content= '<ul id="editIcons">'.$this->getNewModulForm().'</ul>';
		}

		// check list and footer for wrap 
		if ($noList == false) {
			// get content
			$this->setContentArray(cnEngine :: getActualContent());
			$content= '<ul id="categories">'.$this->getContentList('item').'</ul>
						<ul>'.$this->getContentListFooter().'</ul>
						<script type="text/javascript">
							<![CDATA[ 
								Sortable.create(\'categories\',{tag:\'li\',onUpdate:function(){populateSortVars()}});
							]]>
						</script>
						';
		}
		
		if ($_GET['cid']) $cidTitle = ' | CID '.$_GET['cid'];
		// return string 
		return '
				<form method="post" name="formeditcontentitem" id="formeditcontentitem">
				<input type="hidden" id="contentLanguageSuffix" name="contentLanguageSuffix" value="'.$this->contentLanguageSuffix.'" />
				<p class="head_right">'.$this->lang['label_content'].' ('.$this->lang['label_id'].' '.$this->pageid.$cidTitle.')</p>
					'.$content.'
				</form>
				';
	}
	
	function showContentList () {
		
		// get limit search 
		$_contentsearchnumber = empty($_POST['contentsearchnumber']) ? 10 : $_POST['contentsearchnumber'];
		$_contentsearchstring = $this->decodeStr($_POST['contentsearch']);
		
		// make query		
		$sqlLimit = ($_POST['contentsearchnumber'] == 'all') ? '' : 'LIMIT 0,'.$_contentsearchnumber;
		$sqlSearchQuery = empty($_contentsearchstring) 	? 'ORDER by tstamp DESC '.$sqlLimit 
		: 
		'AND (	content LIKE \'%'.htmlentities($_contentsearchstring).'%\' 
		 OR contenttitle LIKE \'%'.$_contentsearchstring.'%\' 
		 OR contentsubtitle LIKE \'%'.$_contentsearchstring.'%\') 
		 ORDER by tstamp DESC '.$sqlLimit;

		// get content list
		$this->setContentArray(cnEngine :: getContentListMode($sqlSearchQuery));	
	
		return '
			<form method="post" action="'.$this->makePOSTLink('list').'" name="formeditcontentitem" id="formeditcontentitem">	
			<p class="head_right">'.$this->lang['link_contentlist'].'</p>
			<ul>'.$this->getContentList('list').'</ul>
			<ul><li class="item_footer_list">
					<div class="row_right_clear">
							<input type="text" id="contentsearch" name="contentsearch" value="'.$this->encodeStr($_POST['contentsearch']).'" class="enter_600" />'.$this->makeInputClear('contentsearch').'
							<p style="margin:10px;"></p>
							<input type="button" title="'.$this->lang['content_search'].'" value="'.$this->lang['content_search'].'" name="contentsearchsubmit" onclick="Element.show(\'cn_pagemessage\');this.form.submit();" class="submit_120" />
							'.$this->searchDropDown($_contentsearchnumber).'
					</div>
				</li>
			</ul>
			</form>'.$this->setJavaFocus('contentsearch');
	}

	/**
	 * function showMeta()
	 * @descr	Show page metainformation
	 * @param	-
	 * @return	string	
	 */
	 
	function showMeta() {
		
		$tree = new tree();
		global $CN_GLOBAL;
		
		$setSuffixAlternativePagename = '';
		$splitContentLanguages = cnEngine::getContentLanguage();
		
		// make contenttitle for each language
		foreach ($splitContentLanguages as $value) {
			if ($value != 'default') {
			$alternativeLanguages .= '<li class="item_noborder">
										<div class="row_left"><div class="label_left">'.$this->lang['content_pagetitle'].' ('.$CN_GLOBAL['content_language'][$value].')</div><input type="text" name="section[pagename_'.$value.']" value="'.$this->encodeStr($this->getAlternativePagename($value)).'" class="width_600" /></div>
									</li>';
			} 
		}
		
		$content= '<form method="post" action="'.$this->makePOSTLink().'" name="formEditSubmit" id="formEditSubmit">
							<p class="head_right">'.$this->lang['label_meta'].' ('.$this->encodeStr($this->pagename).' | '.$this->lang['label_id'].' '.$this->pageid.')</p>
							<ul>
							<li class="item_noborder">
								<div class="row_left"><div class="label_left">'.$this->lang['content_pagetitle'].'</div><input type="text" id="section_pagename" name="section[pagename]" value="'.$this->encodeStr($this->pagename).'" class="width_600" /></div>
							</li>
							'.$alternativeLanguages.'
							<li class="item_noborder">
								<div class="row_left"><div class="label_left">'.$this->lang['content_template'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'section_template', 'file','single').'</div><input type="text" name="section[template]" id="section_template" class="pad_3" value="'.$this->template.'" />'.$this->makeInputClear('section_template').'</div>
								<div class="row_left"><div class="label_left">'.$this->lang['content_mtemplate'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'section_mtemplate', 'file','single').'</div><input type="text" name="section[mtemplate]" id="section_mtemplate" class="pad_3" value="'.$this->mtemplate.'" />'.$this->makeInputClear('section_mtemplate').'</div>
								<div class="row_left"><div class="label_left">'.$this->lang['content_image'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'section_pageimage', 'imageedit','single').'</div><input type="text" name="section[pageimage]" id="section_pageimage" class="pad_3" value="'.$this->pageimage.'" />'.$this->makeInputClear('section_pageimage').'</div>
								<div class="row_left"><div class="label_left">'.$this->lang['content_syskey'].'</div><input type="text" name="section[syskey]" id="section_syskey" class="pad_3" value="'.$this->encodeStr($this->syskey).'" />'.$this->makeInputClear('section_syskey').'</div>
								<div class="row_left"><div class="label_left">'.$this->lang['content_description'].'</div><input type="text" name="section[description]" id="section_description" class="pad_3" value="'.$this->encodeStr($this->description).'" />'.$this->makeInputClear('section_description').'</div>
								<div class="row_left"><div class="label_left">'.$this->lang['content_urlid'].' '.$this->makeUploadPopUp('', 'section_pageurl', 'getID','single').'</div><input type="text" name="section[pageurl]" id="section_pageurl" class="pad_3" value="'.$this->pageurl.'" />'.$this->makeInputClear('section_pageurl').'</div>
								<div class="row_clear"></div>
								<div class="row_left"><div class="label_left">'.$this->lang['content_pagetype'].'</div>'.$this->pagetypeDropDown($this->pagetype).'</div>
								<div class="row_left"><div class="label_left">'.$this->lang['content_move'].'</div><select name="target_section_id">';

		$addNewPageOptionMenu= '';
		$currentSection= $tree->GetNodeInfo($this->pageid);
		
		$tree->Full('');
		while ($item= $tree->NextRow()) {
			$selectValue= ($item['pageid'] == $this->pageid) ? 'selected' : '';
			$selectValueOption= ($item['pageid'] == $this->pageid) ? 'checked="selected"' : '';
			$selectNameSpacing= str_repeat('&nbsp;', 2 * $item['pagelevel']);
			$selectNameSpacingWide= str_repeat('&nbsp;', 5 * $item['pagelevel']);
			$selectNameBefore= ($item['pageid'] == $this->pageid) ? '<strong>' : '';
			$selectNameAfter= ($item['pageid'] == $this->pageid) ? '</strong>' : '';
			if ($item['pageid'] == CN_IDROOT) {
				$item['pagename'.$this->contentLanguageSuffix] = 'Root';
				
				// additinal button to generate new page in root node
				$addNewPageAdditionalButton = '<input type="button" title="'.$this->lang['meta_insert_page'].'" value="'.$this->lang['meta_insert_page'].'" class="submit_120" onclick="$(\'showaddnewpage\').value=1;$(\'new_target_section_id\').value='.$item['pageid'].';$(\'formEditSubmit\').submit();" />';
			}
				// for option (top)
				$content .= '
				<option value="'.$item['pageid'].'" '.$selectValue.' >'.$selectNameSpacing.$selectNameBefore.$this->encodeStr($item['pagename'.$this->contentLanguageSuffix]).$selectNameAfter.'</option>';
			
				// for add new page (bottom)
				$addNewPageOptionMenu .= '
				<ul>
					<li style="padding-bottom: 0px;padding-left: 100px;">'.$selectNameSpacingWide.$selectNameBefore.$this->encodeStr($item['pagename'.$this->contentLanguageSuffix]).$selectNameAfter.'</li>
					<li style="padding-bottom: 15px;">
						<small>'.$this->lang['meta_insert_page_after'].'</small>
						<a href="#" onclick="$(\'showaddnewpage\').value=1;$(\'new_target_section_id\').value='.$item['pageid'].';$(\'formEditSubmit\').submit();"><img src="'.CN_SKINIMAGE.'tool_addsite.gif" border="0"></a>
					</li>
				</ul>';
		}
		$content .= '</select></div>';

		if ($this->pageid != CN_IDROOT) {
			// Prepare the data for position method, assigns a node with all its children to another parent	
			$currentSection= $tree->GetNodeInfo($this->pageid);
			$tree->Parents($this->pageid, array ('pageid'), array ('and' => array ('pagelevel = '. ($currentSection[2] - 1))));
			$item= $tree->NextRow();
			$tree->Branch($item['pageid'], array ('pageid'), array ('and' => array ('pagelevel = '.$currentSection[2])));
			
			while ($item= $tree->NextRow()) {
				$moveUpDownArray[]= $item['pageid'];
			}
			
			$arrayCount= 0;
			$endArray= count($moveUpDownArray);

			if ($endArray > 1) {
				$content .= '<div class="row_left"><div class="width_400">'.$this->lang['content_position'].'</div>
							<p style="margin: 5px;"></p>';
				$linkUp= '';
				$linkDown= '';
				foreach ($moveUpDownArray as $value) {
					$arrayCount ++;
					if ($value == $this->pageid && $arrayCount != 1) {
						$linkUp= '<input type="button" title="'.$this->lang['button_up'].'" value="'.$this->lang['button_up'].'"class="submit_120" onclick="changeUrl(\''.$this->makeCNurl($_SERVER['PHP_SELF'],'','','pageaction=moveup&position='.$moveUpDownArray[($arrayCount-2)]).'\');" />';
					}
					if ($value == $this->pageid && $arrayCount != $endArray) {
						$linkDown= '<input type="button" title="'.$this->lang['button_down'].'" value="'.$this->lang['button_down'].'" class="submit_120" onclick="changeUrl(\''.$this->makeCNurl($_SERVER['PHP_SELF'],'','','pageaction=movedown&position='.$moveUpDownArray[($arrayCount)]).'\');" />';
					}
				}
				$linkPipe= ((!empty ($linkUp) && empty ($linkDown)) || (empty ($linkUp) && !empty ($linkDown))) ? '' : '&nbsp;&nbsp;';
				$content .= $linkUp.$linkPipe.$linkDown.'</div>';
			}
		}
		$content .= '<div class="row_clear"></div>
					</li>';
					
		// check last site in tree
		$deleteButton= ($this->pagelevel == 0 || ( $this->pagelevel == 1 && $endArray <= 1 )) ? 
			'' 
			: 
			'<input type="hidden" id="setdeletepage" name="setdeletepage" value="" />
			<input type="button" title="'.$this->lang['button_deletepage'].'" value="'.$this->lang['button_deletepage'].'" onclick="if(confirm(\''.$this->lang['content_confirmdelete'].'\')==true){$(\'setdeletepage\').value=1;this.form.submit();}" class="submit_120" />
			';

		$content .= '<li class="item_footer" id="showmetabutton">
												<div class="row_right_clear">
													<input type="hidden" id="setsavepage" name="setsavepage" value="" />
													<input type="hidden" id="duplicatepage" name="duplicatepage" value="" />
													<input type="button" title="'.$this->lang['button_save'].'" value="'.$this->lang['button_save'].'" onclick="$(\'setsavepage\').value=1;Element.show(\'cn_pagemessage\');this.form.submit();" class="submit_120" />
													<input type="button" title="'.$this->lang['button_duplicatepage'].'" value="'.$this->lang['button_duplicatepage'].'" onclick="$(\'duplicatepage\').value=1;Element.show(\'cn_pagemessage\');this.form.submit();" class="submit_120" />
													'.$deleteButton.$addNewPageAdditionalButton.'
												</div>
											</li>
										</ul>
							</ul>
							<p class="head_right" style="border-top: none;">'.$this->lang['label_addpage'].'</p>
							<ul>
								<li class="item_noborder">
								<div class="row_right_clear">'.$this->makeToggleLink('addpage').' <strong>'.$this->lang['meta_new_page_after'].'</strong>
									<div id="addpage" style="display:none;">
										<p style="margin: 10px;"></p>
										<input type="hidden" id="new_target_section_id" name="new_target_section_id" value="" />
										<input type="hidden" id="showaddnewpage" name="showaddnewpage" value="" />
										'.$addNewPageOptionMenu.'
										<p style="padding-top: 10px;clear:left;"></p>
									</div>
								</div>
								</div>
								</li>
							</ul>
						</form>
					';
		$content .= $this->setJavaFocus('section_pagename');
		
		return $content;
	}

	/**
	 * function showMetaAddNewPage()
	 * @descr	Show formular new page metainformation
	 * @param	-
	 * @return	string		
	 */
	 
	function showMetaAddNewPage() {
		global $CN_GLOBAL;
		$checkTitleArray = '';
		$splitContentLanguages = cnEngine::getContentLanguage();
		
		foreach ($splitContentLanguages as $value) {
			if ($value != 'default') {
			$alternativeLanguages .= '<li class="item_noborder">
										<div class="row_left">
											<div class="label_left">'.$this->lang['content_pagetitle'].' ('.$CN_GLOBAL['content_language'][$value].')</div>
											<input type="text" id="section[pagename_'.$value.']" name="section[pagename_'.$value.']" value="" class="width_600" />
										</div>
									</li>';
			$checkAlternativeTitle .= '
					if($(\'section[pagename_'.$value.']\').value==\'\'){$(\'section[pagename_'.$value.']\').focus();returnVar=false;}';
			}
		}
		
		$content= '
				<script language="javascript" type="text/javascript">
				function chkFormular() {
					var returnVar = true;
					'.$checkAlternativeTitle.'
					if($(\'section[pagename]\').value==\'\'){$(\'section[pagename]\').focus();returnVar=false;}
					if (returnVar == false) alert(\''.$this->lang['confirm_empty'].'\');	
					return returnVar;
				}
				</script>
					<form method="post" action="'.$this->makePOSTLink().'" name="formAddSubmit" id="formAddSubmit">
							<input type="hidden" name="new_target_section_id" value="'.$_POST['new_target_section_id'].'" />
							<p class="head_right">'.$this->lang['label_addpage'].' ('.$this->lang['label_after'].' '.$this->lang['label_page'].' '.$this->lang['label_id'].' '.$_POST['new_target_section_id'].')</p>
							<ul>		
								<li class="item_noborder">
									<div class="row_left"><div class="label_left">'.$this->lang['content_pagetitle'].'</div><input type="text" id="section[pagename]" name="section[pagename]" value="" class="width_600" /></div>
								</li>
								'.$alternativeLanguages.'
								<li class="item">
									<div class="row_left"><div class="label_left">'.$this->lang['content_template'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'section_template', 'file','single').'</div><input type="text" name="section[template]" id="section_template" value="" /></div>
									<div class="row_left"><div class="label_left">'.$this->lang['content_mtemplate'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'section_mtemplate', 'file','single').'</div><input type="text" name="section[mtemplate]" id="section_mtemplate" value="" /></div>
									<div class="row_left"><div class="label_left">'.$this->lang['content_image'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'section_pageimage', 'imageedit','single').'</div><input type="text" name="section[pageimage]" id="section_pageimage" value="" /></div>
									<div class="row_left"><div class="label_left">'.$this->lang['content_syskey'].'</div><input type="text" name="section[syskey]" value="" /></div>
									<div class="row_left"><div class="label_left">'.$this->lang['content_description'].'</div><input type="text" name="section[description]" value="" /></div>
									<div class="row_left"><div class="label_left">'.$this->lang['content_pagetype'].'</div>'.$this->pagetypeDropDown(0).'</div>
									<div class="row_clear"></div>
								</li>
								<li class="item_footer">
									<div class="row_right_clear">
										<input type="hidden" id="setsavenewpage" name="setsavenewpage" value="" />
										<input type="button" title="'.$this->lang['button_save'].'" value="'.$this->lang['button_save'].'" onclick="if(chkFormular()==true){$(\'setsavenewpage\').value=1;this.form.submit();}" class="submit_120" />
										<input type="button" title="'.$this->lang['button_cancel'].'" value="'.$this->lang['button_cancel'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />
									</div>
								</li>
							</form>';
		$content .= $this->setJavaFocus('section[pagename]');

		return $content;
	}

	/**
	 * function showConfig()
	 * @descr	Show page config
	 * @param	-
	 * @return	string		
	 */
	 
	function showConfig() {
			$content = '<p class="head_right">'.$this->lang['label_config'].'</p>
 				<form method="post" action="'.$this->makePOSTLink('config','true').'" name="formeditconfig" id="formeditconfig">
				<input type="hidden" name="contentLanguageSuffix" id="contentLanguageSuffix" value="'.$this->contentLanguageSuffix.'" />
					<ul>';
			if ($this->checkAccess('config_templateconfiguration'))
			$content .= '<li class="item">
									<div class="row_noborder">'.$this->makeToggleLink('show1').' <strong>'.$this->lang['config_templateconfiguration'].'</strong></div>
										<div id="show1" style="display:none;">
											<div class="row_clear">&nbsp;</div>
											<div class="row_left_wide"><div class="label_left">'.$this->lang['config_master'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'mastertemplate', 'file','single').'</div><input type="text" class="pad_3" id="mastertemplate" name="config[mastertemplate]" value="'.$this->configArray[0]['mastertemplate'].'" />'.$this->makeInputClear('mastertemplate').'</div>
											<div class="row_left_wide"><div class="label_left">'.$this->lang['config_content'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'contenttemplate', 'file','single').'</div><input type="text" class="pad_3" id="contenttemplate" name="config[contenttemplate]" value="'.$this->configArray[0]['contenttemplate'].'" />'.$this->makeInputClear('contenttemplate').'</div>
											<div class="row_left_wide"><div class="label_left">'.$this->lang['config_navigation_l1'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'navigationl1', 'file','single').'</div><input type="text" class="pad_3" id="navigationl1" name="config[navigationl1]" value="'.$this->configArray[0]['navigationl1'].'" />'.$this->makeInputClear('navigationl1').'</div>
											<div class="row_left_wide"><div class="label_left">'.$this->lang['config_navigation_l2'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'navigationl2', 'file','single').'</div><input type="text" class="pad_3" id="navigationl2" name="config[navigationl2]" value="'.$this->configArray[0]['navigationl2'].'" />'.$this->makeInputClear('navigationl2').'</div>
											<div class="row_left_wide"><div class="label_left">'.$this->lang['config_contentteaser'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'teasercontenttemplate', 'file','single').'</div><input type="text" class="pad_3" id="teasercontenttemplate" name="config[teasercontenttemplate]" value="'.$this->configArray[0]['teasercontenttemplate'].'" />'.$this->makeInputClear('teasercontenttemplate').'</div>
											<div class="row_left_wide"><div class="label_left">'.$this->lang['config_print'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'printtemplate', 'file','single').'</div><input type="text" class="pad_3" id="printtemplate" name="config[printtemplate]" value="'.$this->configArray[0]['printtemplate'].'" />'.$this->makeInputClear('printtemplate').'</div>						
											<div class="row_left_wide"><div class="label_left">'.$this->lang['config_special'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'specialtemplate', 'file','single').'</div><input type="text" class="pad_3" id="specialtemplate" name="config[specialtemplate]" value="'.$this->configArray[0]['specialtemplate'].'" />'.$this->makeInputClear('specialtemplate').'</div>
											<div class="row_left_wide"><div class="label_left">'.$this->lang['config_pageimagetemplate'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'pageimagetemplate', 'file','single').'</div><input type="text" class="pad_3" id="pageimagetemplate" name="config[pageimagetemplate]" value="'.$this->configArray[0]['pageimagetemplate'].'" />'.$this->makeInputClear('pageimagetemplate').'</div>
											<div class="row_left_wide"><div class="label_left">'.$this->lang['config_pageheadertemplate'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'pageheadertemplate', 'file','single').'</div><input type="text" class="pad_3" id="pageheadertemplate" name="config[pageheadertemplate]" value="'.$this->configArray[0]['pageheadertemplate'].'" />'.$this->makeInputClear('pageheadertemplate').'</div>
											<div class="row_left_wide"><div class="label_left">'.$this->lang['config_pagefootertemplate'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'pagefootertemplate', 'file','single').'</div><input type="text" class="pad_3" id="pagefootertemplate" name="config[pagefootertemplate]" value="'.$this->configArray[0]['pagefootertemplate'].'" />'.$this->makeInputClear('pagefootertemplate').'</div>
											<div class="row_clear"></div>
										</div>
								</li>';
		if ($this->checkAccess('config_globalconfiguration'))
		$content .= '<li class="item">
								<div class="row_noborder">'.$this->makeToggleLink('show2').' <strong>'.$this->lang['config_globalconfiguration'].'</strong></div>
								<div id="show2" style="display:none;">
									<div class="row_clear">&nbsp;</div>
									<div class="row_left_wide"><div class="label_left">'.$this->lang['config_sitetitle'].'</div><input type="text" class="pad_3" id="sitetitle" name="config[sitetitle]" value="'.$this->encodeStr($this->configArray[0]['sitetitle']).'" />'.$this->makeInputClear('sitetitle').'</div>						
									<div class="row_left_wide"><div class="label_left">'.$this->lang['config_startpid'].' '.$this->makeUploadPopUp('', 'startpageid', 'getID','single').'</div><input type="text" class="pad_3" id="startpageid" name="config[startpageid]" value="'.$this->configArray[0]['startpageid'].'" />'.$this->makeInputClear('startpageid').'</div>
									<div class="row_left_wide"><div class="label_left">'.$this->lang['config_teasercontentpid'].' '.$this->makeUploadPopUp('', 'teasercontentpageid', 'getID').'</div><input type="text" class="pad_3" id="teasercontentpageid" name="config[teasercontentpageid]" value="'.$this->configArray[0]['teasercontentpageid'].'" />'.$this->makeInputClear('teasercontentpageid').'</div>						
									<div class="row_left_wide"><div class="label_left">'.$this->lang['config_syskey'].'</div><input type="text" class="pad_3" id="globalsyskey" name="config[globalsyskey]" value="'.$this->configArray[0]['globalsyskey'].'" />'.$this->makeInputClear('globalsyskey').'</div>
									<div class="row_left_wide"><div class="label_left">'.$this->lang['config_pageimage'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'globalpageimage', 'imageedit','single').'</div><input type="text" class="pad_3" id="globalpageimage" name="config[globalpageimage]" value="'.$this->configArray[0]['globalpageimage'].'" />'.$this->makeInputClear('globalpageimage').'</div>
									<div class="row_left_wide"><div class="label_left">'.$this->lang['config_inline_edit'].'</div>'.$this->contentCheckBox('config[inlineedit]', $this->configArray[0]['inlineedit']).'</div>
									<div class="row_left_wide"><div class="label_left">'.$this->lang['config_smarty_cache'].'</div>'.$this->contentCheckBox('config[smartycache]', $this->configArray[0]['smartycache']).'</div>	
									<div class="row_clear"></div>
								</div>
							</li>';
		if ($this->checkAccess('config_metaconfiguration')) {
			$content .= '<li class="item">
							<div class="row_noborder">'.$this->makeToggleLink('show3').' <strong>'.$this->lang['config_metaconfiguration'].'</strong></div>
								<div id="show3" style="display:none;">
									<div class="row_clear">&nbsp;</div>';
			if ($this->checkAccess('config_metaconfiguration_copyright'))
			$content .= '<div class="row_left_wide"><div class="label_left">'.$this->lang['config_metainfo'].'</div><textarea style="height: 5em;" name="config[metainfo]">'.$this->encodeStr($this->configArray[0]['metainfo']).'</textarea></div>';						
			if ($this->checkAccess('config_metaconfiguration_description'))
			$content .= '<div class="row_left_wide"><div class="label_left">'.$this->lang['config_metadescription'].'</div><textarea style="height: 5em;" name="config[metadescription]">'.$this->encodeStr($this->configArray[0]['metadescription']).'</textarea></div>';						
			if ($this->checkAccess('config_metaconfiguration_keywords'))
			$content .= '<div class="row_left_wide"><div class="label_left">'.$this->lang['config_metakeywords'].'</div><textarea style="height: 5em;" name="config[metakeywords]">'.$this->encodeStr($this->configArray[0]['metakeywords']).'</textarea></div>';						
			$content .= '<div class="row_clear"></div>
									</div>
								</li>';
		}
		if ($this->checkAccess('config_functions'))
		$content .= '<li class="item">
								<div class="row_noborder">'.$this->makeToggleLink('show4').' <strong>'.$this->lang['config_functions'].'</strong></div>
									<div id="show4" style="display:none;">
									<div class="row_clear">&nbsp;</div>
									<div class="row_left_wide"><div class="label_left">'.$this->lang['config_backupMySQL'].'</div><input type="button" title="'.$this->lang['config_startbackupMySQL'].'" value="'.$this->lang['config_startbackupMySQL'].'" class="submit_120"  onclick="window.open(\'./library/function.backupdb.php\');" /></div>
									<div class="row_left_wide"><div class="label_left">'.$this->lang['config_remove_cache'].'</div>'.$this->makeCNAjaxLink($this->lang['config_start_remove_cache'],'./library/function.removecache.php','formeditconfig').'</div>			
									<div class="row_left_wide"><div class="label_left">'.$this->lang['config_cleanupDB'].'</div>'.$this->makeCNAjaxLink($this->lang['config_startcleanupDB'],'./library/function.cleandb.php','formeditconfig').'</div>
									<div class="row_clear"></div>
								</div>
							</li>';
		if ($this->checkAccess('config_backend_languages'))						
		$content .= '<li class="item">
								<div class="row_noborder">'.$this->makeToggleLink('show5').' <strong>'.$this->lang['config_backend_languages'].'</strong></div>
									<div id="show5" style="display:none;">
									<div class="row_clear">&nbsp;</div>
									<div class="row_left_wide"><div class="label_left">'.$this->lang['config_change_backend_language'].'</div>'.$this->backendLanguageDropDown('config[backendlanguage]',$this->configArray[0]['backendlanguage']).'</div>			
									<div class="row_clear"></div>
								</div>
							</li>';
		if ($this->checkAccess('config_languages'))						
		$content .= '<li class="item">
								<div class="row_noborder">'.$this->makeToggleLink('show6').' <strong>'.$this->lang['config_languages'].'</strong></div>
									<div id="show6" style="display:none;">
									<div class="row_clear">&nbsp;</div>
									<div class="row_left_wide"><div class="label_left">'.$this->lang['config_new_website_language'].'</div>'.$this->frontendLanguageDropDown('newwebsitelangid').'&nbsp;
										<input type="hidden" name="newlanguage" id="newlanguage" value="" />
										<input type="button" title="'.$this->lang['config_install_language'].'" value="'.$this->lang['config_install_language'].'" class="submit_120" onclick="if(confirm(\''.$this->lang['config_confirm_install_language'].'\')==true){$(\'newlanguage\').value=1;this.form.submit();}" />
									</div>
									<div class="row_clear"></div>
								</div>
							</li>';
		if ($this->checkAccess('config_constants'))						
		$content .= '<li class="item">
								<div class="row_noborder">'.$this->makeToggleLink('show7').' <strong>'.$this->lang['config_manage_constants'].'</strong></div>
									<div id="show7" style="display:none;">
									<div class="row_clear">&nbsp;</div>
									<div class="row_no_border">
									<input type="button" title="'.$this->lang['config_constants_clickedit'].'" value="'.$this->lang['config_constants_clickedit'].'"id="constantsForm" class="submit_120" />
									<script language="javascript" type="text/javascript">
									new Ajax.InPlaceEditor($(\'constantsForm\'), \'./library/function.constants.php?action=save&lang='.$this->lang['language_key'].'\',
									    { callback: function(form, value) { return \'constants=\' + escape(value)},
										rows:15, cancelText:\''.$this->lang['button_cancel'].'\', okText:\''.$this->lang['button_save'].'\',
									    loadTextURL: \'./library/function.constants.php?action=load\'});
									</script>
									</div>
									<div class="row_clear"></div>
								</div>
							</li>';							
		if ($this->checkAccess('config_infocn'))
		$content .= '<li class="item">
								<div class="row_noborder"><strong>'.$this->lang['config_infocn'].'</strong></div>
								<div class="row_left_wide"><div class="label_left">'.$this->lang['config_infocopyright'].'</div><a href="http://www.contentnow.mf4k.de" target="_blank">www.contentnow.mf4k.de</a></div>
								<div class="row_left_wide"><div class="label_left">'.$this->lang['config_infoversion'].' '.CN_VERSION.'</div>&nbsp;</div>
								<div class="row_left_wide"><div class="label_left">SourceForge:</div><a href="http://sourceforge.net/projects/contentnow/" target="_blank"><img src="'.CN_SKINIMAGE.'sflogo-88x31.jpg" width="88" height="31" border="0" alt="SourceForge.net" /></a></div>							
								<div class="row_clear"></div>
							</li>';	
							
		$content .= '<li class="item_footer">
								<div class="row_right_clear">
									'.$this->makeCNAjaxLink($this->lang['button_save'],'./library/function.saveconfig.php','formeditconfig').
									$this->contentLanguageDropDown('langid',$this->contentLanguage,1).'
								</div>
							</li>					
							</ul>
							</form>';
		return $content;
	}

	/**
	 * function showModulConfig()
	 * @descr	Show modul elements for install/deinstall
	 * @class	modul
	 * @param	-
	 * @return	string	
	 */
	 
	function showModulConfig() {
		$this->getAllModuls();
		$cnModul= new cnModul();
		$content= '<p class="head_right">'.$this->lang['label_moduls'].'</p>'.$cnModul->getModulDir($this->allModulsArray,$this->lang);
		return $content;
	}

	/**
	 * function showUserForm()
	 * @descr	Show user form
	 * @param	-
	 * @return	string		
	 */
	 
	function showUserForm() {
		$content= '<form method="post" action="'.$this->makePOSTLink().'" name="newuseredit" id="newuseredit">
					<p class="head_right">'.$this->lang['user_label_management'].'</p>
					<ul>
							'.$this->getUserList().'			
						</ul>';
		if (!$_POST['newuser']) {
			$content .= '<ul>
						<li class="item_footer">
							<div class="row_right_clear">
								<input type="hidden" id="newuser" name="newuser" value="" />
								<input type="button" title="'.$this->lang['user_newuser'].'" value="'.$this->lang['user_newuser'].'" class="submit_120" onclick="$(\'newuser\').value=1;this.form.submit();" />
							</div>
						</li>
						</ul>';
		}
		$content .= '</form>';
		return $content;
	}

	/**
	 * function getContentList()
	 * @descr	Show content elements
	 * @param	$showMode: list or item
	 * @return	string	
	 */

	function getContentList($showMode='') {

	switch ($showMode) {
			
		default:
		if (empty ($this->contentArray)) {
			// no items found
			$content= '<li class="item">'.$this->lang['content_noitems'].'</li>';
		} else {
			$content= '';
			// start loop
			foreach ($this->contentArray as $id => $value) {

				switch ($value['contenttype']) {

					case "3" :
						// generate preview text for modul
						$_previewtext= explode('|*|', $value['content']);
						// array pos 1 -> modul name
						$_title = $this->encodeStr(empty($value['contenttitle']) ? $value['contentsubtitle'] : $value['contenttitle']);
						$_headline= '<strong>'.$this->lang['text_modul'].' '.$_previewtext[1].'</strong>';
						$_content= '<span class="grey">'.substr(strip_tags($_title), 0, 100).'</span>';
						break;

					case "2" :
						// generate preview php script
						$_title = $this->encodeStr(empty($value['contenttitle']) ? $value['contentsubtitle'] : $value['contenttitle']);
						$_headline= '<strong>'.$this->lang['text_contenturl'].' '.substr(strip_tags($_title), 0, 100).'</strong>';
						$_content= '<span class="grey">'.substr(strip_tags($value['contenturl']), 0, 100).' ...</span>';
						break;

					case "1" :
						// generate preview text for teaser content
						$_title = $this->encodeStr(empty($value['contenttitle']) ? $value['contentsubtitle'] : $value['contenttitle']);
						$_headline= '<strong>'.$this->lang['text_teasercontent'].' '.substr(strip_tags($_title), 0, 100).'</strong>';
						$_content= '<span class="grey">'.substr(strip_tags($value['content']), 0, 100).' ...</span>';
						break;

					default :
						// generate preview text for text element
						$_title = $this->encodeStr(empty($value['contenttitle']) ? $value['contentsubtitle'] : $value['contenttitle']);
						$_headline= '<strong>'.substr(strip_tags($_title), 0, 100).'</strong>';
						$_content= '<span class="grey">'.substr(strip_tags($value['content']), 0, 100).' ...</span>';
						break;
				}

				// check hidden content
				$_hidden= ($value['hidden'] == 1) ? ' <strong>'.$this->lang['text_hidden'].'</strong>' : '';

				// check publication date
				$now = adodb_getdate();
				$notpublished = ($now['0'] < $value['starttime']) ? '<span style="color:green;">'.$this->lang['content_not_published'].'</span>' : '';
				$timeout = ($now['0'] > $value['endtime']) ? '<span style="color:green;">'.$this->lang['content_timeout'].'</span>' : '';
				
				if ( empty($notpublished)  && empty($timeout) ) {
					$publishedout =$this->lang['content_published'];
				} else {
					$publishedout = empty($notpublished) ? $timeout : $notpublished; 
				}
				
				// prepare for output  
				$content .= '
					<li id="item_'.$value['id'].'" class="item'.$this->checkContentType($value['contenttype']).'">
						'.$this->makeCNImageLink(CN_SKINIMAGE.'tool_editcontent.gif', $this->lang['button_edit'],$_SERVER['PHP_SELF'],'content',$value['pid'],'','_self','action=edit&cid='.$value['id']).'
						'.$this->makeCNAjaxImageLink(CN_SKINIMAGE.'tool_copy.gif','./library/function.copyitem.php?cid='.$value['id'].'&self='.$_SERVER['PHP_SELF'].'&mode='.$this->mode.'&pageid='.$this->pageid.'&lang='.$this->lang['language_key'],'formeditcontentitem','','','copyitem','',$this->lang['button_copy']).'
						'.$this->makeCNImageLink(CN_SKINIMAGE.'tool_delete.gif', $this->lang['button_delete'],$_SERVER['PHP_SELF'],'content',$value['pid'],'','_self','action=delete&cid='.$value['id'],'confirm').'
						<small>CID '.$value['id'].' | '.$this->makeDate($value['starttime']).' | '.$publishedout.'</small>
						<p style="margin:5px"></p>
						'.$_headline.$_hidden.'
						<p style="margin:5px"></p>
						'.$_content.'
					</li>';
			}
		}
		return $content;

		case 'list':
		if (empty ($this->contentArray)) {
			// no items found
			$content= '<li class="item">'.$this->lang['content_noitems'].'</li>';
		} else {
			$content= '';
			
			// start loop
			foreach ($this->contentArray as $id => $value) {
				
				// prepare output
				$title = '&nbsp;&nbsp;&nbsp;&nbsp;<span class="grey">'.$this->getPageTitle($value['pid']).'</span>';
				$siteLink= $this->makeCNImageLink(CN_SKINIMAGE.'tool_template.gif', $this->lang['button_gopage'], $_SERVER['PHP_SELF'], 'content', $value['pid'], '').$title;
				
				switch ($value['contenttype']) {

					case "3" :
						// generate preview text for modul
						$_previewtext= explode('|*|', $value['content']);
						// array pos 1 -> modul name
						$_headline= $siteLink.' | <strong>'.$this->lang['text_modul'].' '.$_previewtext[1].'</strong> | '.$this->encodeStr(substr($value['contenttitle'], 0, 40));
						break;

					case "2" :
						// generate preview php script
						$_headline= $siteLink.' | <strong>'.$this->lang['text_contenturl'].' '.$this->encodeStr(substr($value['contenttitle'], 0, 40)).'</strong> | '.substr(strip_tags($value['contenturl']), 0, 40).' ...';
						break;

					case "1" :
						// generate preview text for teaser content
						$_headline= $siteLink.' | <strong>'.$this->lang['text_teasercontent'].' '.$this->encodeStr(substr($value['contenttitle'], 0, 30)).'</strong> | '.substr(strip_tags($value['content']), 0, 40).' ...';
						break;

					default :
						// generate preview text for text element
						$_headline= $siteLink.' | <strong>'.$this->lang['text_text'].' '.$this->encodeStr(substr($value['contenttitle'], 0, 40)).'</strong> | '.substr(strip_tags($value['content']), 0, 40).' ...';
						break;
				}

				// check hidden content
				$_hidden= ($value['hidden'] == 1) ? ' <strong>'.$this->lang['text_hidden'].'</strong>' : '';
				
				// check publication date
				$now = adodb_getdate();
				$notpublished = ($now['0'] < $value['starttime']) ? '<small style="color:green;">'.$this->lang['content_not_published'].'</small>' : '<small>'.$this->lang['content_published'].'</small>';
				
				// prepare for output
				$content .= '
					<li id="item_'.$value['id'].'" class="item_list'.$this->checkContentType($value['contenttype']).'">
						'.$this->makeCNImageLink(CN_SKINIMAGE.'tool_editcontent.gif', $this->lang['button_edit'],$_SERVER['PHP_SELF'],'content',$value['pid'],'','_self','action=edit&cid='.$value['id']).'
						'.$_headline.$_hidden.' | '.$notpublished.'
					</li>';
			}
		}
		return $content;
		}
	}

	/**
	 * function getContentEditForm()
	 * @descr	Show content edit formular
	 * @param	sid: sort id, number in array = sort in mysql
	 * @return	string
	 * @switch	default: normal text elements | 3: modul element | 2: dynamic php file
	 */

	function getContentEditForm() {

		switch ($this->contentArray[0]['contenttype']) {

			case "3" :
				// parse modul content
				$content= ' 
					<input type="hidden" name="content[id]" value="'.$this->contentArray[0]['id'].'" />
					<input type="hidden" name="content[tstamp]" value="'.$this->getActualTimeStamp().'" />
					<input type="hidden" name="content[sort]" value="'.$this->contentArray[0]['sort'].'" />				
					<input type="hidden" name="contentLanguageSuffix" id="contentLanguageSuffix" value="'.$this->contentLanguageSuffix.'" />
					<li class="item">
						<div class="row_border">
							<div class="label_left">'.$this->lang['content_title'].'</div>
							<input type="text" id="contenttitle" name="content[contenttitle]" value="'.$this->encodeStr($this->contentArray[0]['contenttitle']).'" class="width_400" />
						</div>
				<p style="margin:5px"></p>
						<div class="row_border">
							<div class="label_left">'.$this->lang['content_subtitle'].'</div>
							<input type="text" name="content[contentsubtitle]" value="'.$this->encodeStr($this->contentArray[0]['contentsubtitle']).'" class="width_400" />
							</div>						
				<p style="margin:5px"></p>							
						<div class="row_border">
							<div class="label_left">'.$this->lang['content_contentsyskey'].'</div>
							<div class="label_left_200">
								<input type="text" name="content[contentsyskey]" id="content_contentsyskey" value="'.$this->encodeStr($this->contentArray[0]['contentsyskey']).'" class="width_120" />'.$this->makeInputClear('content_contentsyskey').'
							</div>
							<div class="label_left">'.$this->lang['content_hidden'].' '.$this->contentCheckBox('content[hidden]', $this->contentArray[0]['hidden']).'</div>
							<div class="label_left_200">'.$this->lang['content_contenttype'].' '.$this->contenttypeDropDown($this->contentArray[0]['contenttype']).'</div>
						</div>
				<p style="margin:5px"></p>
							<div class="row_border">
									<div class="label_left">'.$this->lang['content_date'].'</div>
									<div class="label_left_200">
										<input type="text" id="content_starttime" name="content[starttime]" value="'.$this->makeDate($this->contentArray[0]['starttime']).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_starttime').'
									</div>
									<div class="label_left">'.$this->lang['content_enddate'].'</div>
									<div class="label_left_200">
										<input type="text" id="content_endtime" name="content[endtime]" value="'.$this->makeDate($this->contentArray[0]['endtime']).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_endtime').$this->makeInputClear('content_endtime',CN_TIMETOLIVE).'
									</div>
							</div>
				<p style="margin:15px"></p>	
					<div class="row_noborder"><strong>'.$this->lang['modul_configuration'].'</strong></div>
						'.$this->getSelectedModulParam($this->contentArray[0]['content']).'
					</li>
					<li class="item_footer">
							'.$this->makeCNAjaxLink($this->lang['button_save'],'./library/function.savemodul.php','formeditcontentitem').'
							'.$this->makeCNAjaxLink($this->lang['button_save_preview'],'./library/function.savemodul.php','formeditcontentitem','../index.php?inline='.$this->configArray[0]['inlineedit'].'&pageid='.$this->pageid.'&clang='.$this->contentLanguage).'
							'.$this->makeCNAjaxLink($this->lang['button_save_close'],'./library/function.savemodul.php','formeditcontentitem',$this->makePOSTLink(),'self').'
							<input type="button" title="'.$this->lang['button_cancel_close'].'" value="'.$this->lang['button_cancel_close'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />
					</li>';
				$content .= $this->setJavaFocus('contenttitle');
				break;

			case "2" :
				// dynamic php script
				$content= '
						<input type="hidden" name="content[id]" value="'.$this->contentArray[0]['id'].'" />
						<input type="hidden" name="content[tstamp]" value="'.$this->getActualTimeStamp().'" />						
						<input type="hidden" name="content[sort]" value="'.$this->contentArray[0]['sort'].'" />
						<input type="hidden" name="contentLanguageSuffix" id="contentLanguageSuffix" value="'.$this->contentLanguageSuffix.'" />
						<li class="item" style="border-top: 1px solid #CCC;">
							<div class="row_border">
								<div class="label_left">'.$this->lang['content_title'].'</div>
								<input type="text" id="contenttitle" name="content[contenttitle]" value="'.$this->encodeStr($this->contentArray[0]['contenttitle']).'" class="width_400" />
							</div>
						<p style="margin:5px"></p>
							<div class="row_border">
								<div class="label_left">'.$this->lang['content_subtitle'].'</div>
								<input type="text" name="content[contentsubtitle]" value="'.$this->encodeStr($this->contentArray[0]['contentsubtitle']).'" class="width_400" />
							</div>						
						<p style="margin:5px"></p>
							<div class="row_border">
								<div class="label_left">'.$this->lang['content_contentsyskey'].'</div>
								<div class="label_left_200">
									<input type="text" name="content[contentsyskey]" id="content_contentsyskey" value="'.$this->contentArray[0]['contentsyskey'].'" class="width_120" />'.$this->makeInputClear('content_contentsyskey').'
								</div>
								<div class="label_left">'.$this->lang['content_hidden'].' '.$this->contentCheckBox('content[hidden]', $this->contentArray[0]['hidden']).'</div>
								<div class="label_left_200">'.$this->lang['content_contenttype'].' '.$this->contenttypeDropDown($this->contentArray[0]['contenttype']).'</div>
							</div>			
						<p style="margin:5px"></p>							
							<div class="row_border">
									<div class="label_left">'.$this->lang['content_date'].'</div>
									<div class="label_left_200">
										<input type="text" id="content_starttime" name="content[starttime]" value="'.$this->makeDate($this->contentArray[0]['starttime']).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_starttime').'
									</div>
									<div class="label_left">'.$this->lang['content_enddate'].'</div>
									<div class="label_left_200">
										<input type="text" id="content_endtime" name="content[endtime]" value="'.$this->makeDate($this->contentArray[0]['endtime']).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_endtime').$this->makeInputClear('content_endtime',CN_TIMETOLIVE).'
									</div>
							</div>
						<p style="margin:5px"></p>							
							<div class="row_border">
								<div class="label_left">'.$this->lang['content_url'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'contenturl', 'file','single').'</div>
								<input type="text" id="contenturl" name="content[contenturl]" value="'.$this->encodeStr($this->contentArray[0]['contenturl']).'" class="width_400" />
							</div>
						</li>
						<li class="item_footer">
							'.$this->makeCNAjaxLink($this->lang['button_save'],'./library/function.saveitem.php','formeditcontentitem').'
							'.$this->makeCNAjaxLink($this->lang['button_save_preview'],'./library/function.saveitem.php','formeditcontentitem','../index.php?inline='.$this->configArray[0]['inlineedit'].'&pageid='.$this->pageid.'&clang='.$this->contentLanguage).'
							'.$this->makeCNAjaxLink($this->lang['button_save_close'],'./library/function.saveitem.php','formeditcontentitem',$this->makePOSTLink(),'self').'
							<input type="button" title="'.$this->lang['button_cancel_close'].'" value="'.$this->lang['button_cancel_close'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />
							'.$this->makeCNAjaxLink($this->lang['button_newtext'],'./library/function.saveitem.php','formeditcontentitem',$this->makePOSTLink().'&action=new','self').'
						</li>';
				$content .= $this->setJavaFocus('contenttitle');				
				break;

			default :
				// parse text and teaser content
				$content= '
						<input type="hidden" name="content[id]" value="'.$this->contentArray[0]['id'].'" />
						<input type="hidden" name="content[tstamp]" value="'.$this->getActualTimeStamp().'" />						
						<input type="hidden" name="content[sort]" value="'.$this->contentArray[0]['sort'].'" />
						<input type="hidden" name="contentLanguageSuffix" id="contentLanguageSuffix" value="'.$this->contentLanguageSuffix.'" />
						<li class="item" style="border-top: 1px solid #CCC;">
							<div class="row_border">
								<div class="label_left">'.$this->lang['content_title'].'</div>
								<input type="text" id="contenttitle" name="content[contenttitle]" value="'.$this->encodeStr($this->contentArray[0]['contenttitle']).'" class="width_400" />
							</div>
						<p style="margin:5px"></p>
							<div class="row_border">
								<div class="label_left">'.$this->lang['content_subtitle'].'</div>
								<input type="text" name="content[contentsubtitle]" value="'.$this->encodeStr($this->contentArray[0]['contentsubtitle']).'" class="width_400" />
							</div>						
						<p style="margin:5px"></p>
							<div class="row_border">
								<div class="label_left">'.$this->lang['content_contentsyskey'].'</div>
								<div class="label_left_200">
									<input type="text" name="content[contentsyskey]" id="content_contentsyskey" value="'.$this->encodeStr($this->contentArray[0]['contentsyskey']).'" class="width_120" />'.$this->makeInputClear('content_contentsyskey').'
								</div>
								<div class="label_left">'.$this->lang['content_hidden'].' '.$this->contentCheckBox('content[hidden]', $this->contentArray[0]['hidden']).'</div>
								<div class="label_left_200">'.$this->lang['content_contenttype'].' '.$this->contenttypeDropDown($this->contentArray[0]['contenttype']).'</div>
							</div>			
						<p style="margin:5px"></p>							
							<div class="row_border">
									<div class="label_left">'.$this->lang['content_date'].'</div>
									<div class="label_left_200">
										<input type="text" id="content_starttime" name="content[starttime]" value="'.$this->makeDate($this->contentArray[0]['starttime']).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_starttime').'
									</div>
									<div class="label_left">'.$this->lang['content_enddate'].'</div>
									<div class="label_left_200">
										<input type="text" id="content_endtime" name="content[endtime]" value="'.$this->makeDate($this->contentArray[0]['endtime']).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_endtime').$this->makeInputClear('content_endtime',CN_TIMETOLIVE).'
									</div>
							</div>	
							<div class="row_noborder">'.$this->getRichTextEdit('content').'
								<textarea id="content" name="content[content]" style="width:99%;">'.$this->contentArray[0]['content'].'</textarea>
							</div>
						</li>
						<li class="item_footer">
							'.$this->makeCNAjaxLink($this->lang['button_save'],'./library/function.saveitem.php','formeditcontentitem').'
							'.$this->makeCNAjaxLink($this->lang['button_save_preview'],'./library/function.saveitem.php','formeditcontentitem','../index.php?inline='.$this->configArray[0]['inlineedit'].'&pageid='.$this->pageid.'&clang='.$this->contentLanguage).'
							'.$this->makeCNAjaxLink($this->lang['button_save_close'],'./library/function.saveitem.php','formeditcontentitem',$this->makePOSTLink(),'self').'
							<input type="button" title="'.$this->lang['button_cancel_close'].'" value="'.$this->lang['button_cancel_close'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />							
							'.$this->makeCNAjaxLink($this->lang['button_newtext'],'./library/function.saveitem.php','formeditcontentitem',$this->makePOSTLink().'&action=new','self').'	
						</li>';
				$content .= $this->setJavaFocus('contenttitle');
				break;
		}
		return $content;
	}

	/**
	 * function getContentListFooter()
	 * @descr	Show content footer (new element, new modul, sort)
	 * @param	-
	 * @return	string	
	 * @used 	function showContent
	 */

	function getContentListFooter() {

		$copyItem= (empty ($_SESSION['singleContentArray'])) ? '<div id="copyitem"></div>' : '
							<div id="copyitem">
								'.$this->makeCNAjaxImageLink(CN_SKINIMAGE.'tool_insert.gif','./library/function.copyitempaste.php?pid='.$this->pageid,'formeditcontentitem',$this->makePOSTLink(),'true','copyitem','',$this->lang['button_moveitem']).'
								'.$this->makeCNAjaxImageLink(CN_SKINIMAGE.'tool_delinsert.gif','./library/function.copyitemclear.php','formeditcontentitem','','','copyitem','',$this->lang['button_deleteitem']).'
							</div>';
		$content= '<input type="hidden" name="sortItemArray" id="sortItemArray" />
							<li class="item_footer">
								<div class="row_left">
									<input type="button" title="'.$this->lang['button_newtext'].'" value="'.$this->lang['button_newtext'].'" onclick="changeUrl(\''.$this->makePOSTLink().'&action=new\');" class="submit_120" />
									<input type="button" title="'.$this->lang['button_newmodul'].'" value="'.$this->lang['button_newmodul'].'" onclick="changeUrl(\''.$this->makePOSTLink().'&action=modul\');" class="submit_120" />
								</div>
								'.$copyItem.'
							</li>';
		return $content;
	}

	/**
	 * function getNewContentForm()
	 * @descr	Show content edit formular new element
	 * @param	-
	 * @return	string
	 */

	function getNewContentForm() {
		$content= '
					<li class="item">
						<input type="hidden" name="content[sort]" value="'.$this->getMaxSortVal().'" />
						<input type="hidden" name="content[tstamp]" value="'.$this->getActualTimeStamp().'" />
						<div class="row_border">
							<div class="label_left">'.$this->lang['content_title'].' </div>
							<input type="text" id="contenttitle" name="content[contenttitle]" value="" class="width_400" />
						</div>
				<p style="margin:5px"></p>
						<div class="row_border">
							<div class="label_left">'.$this->lang['content_subtitle'].'</div>
							<input type="text" name="content[contentsubtitle]" value="" class="width_400" />
						</div>	
						<div class="row_border">
							<div class="label_left">'.$this->lang['content_syskey'].'</div>
							<div class="label_left_200"><input type="text" name="content[contentsyskey]" value="" class="width_120" /></div>
							<div class="label_left">'.$this->lang['content_hidden'].' '.$this->contentCheckBox('content[hidden]', '0').'</div>
							<div class="label_left_200">'.$this->lang['content_contenttype'].' '.$this->contenttypeDropDown('init', 'false').'</div>
						</div>
				<p style="margin:5px"></p>
						<div class="row_border">
							<div class="label_left">'.$this->lang['content_date'].'</div>
							<div class="label_left_200"><input type="text" id="content_starttime" name="content[starttime]" value="'.$this->makeDate().'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_starttime').'</div>
							<div class="label_left">'.$this->lang['content_enddate'].'</div>
							<div class="label_left_200"><input type="text" id="content_endtime" name="content[endtime]" value="'.$this->makeDate($this->makeTstamp(CN_TIMETOLIVE)).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_endtime').'</div>
						</div>	
					</li>
					<li class="item_footer">
						'.$this->makeCNAjaxLink($this->lang['button_save_and_edit'],'./library/function.newitem.php?pid='.$this->pageid,'formeditcontentitem',$this->makePOSTLink(),'callback','','').' 
						<input type="button" title="'.$this->lang['button_cancel'].'" value="'.$this->lang['button_cancel'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />
					</li>';
				$content .= $this->setJavaFocus('contenttitle');					
		return $content;
	}

	/**
	 * function getNewModulForm()
	 * @descr	Show content element modul
	 * @param	-
	 * @return	string	
	 */

	function getNewModulForm() {

		// get all Moduls
		$this->getAllModuls();
		$cnModul= new cnModul();
		
		if (empty ($this->allModulsArray)) {
			$content= '
						<li class="item"><strong>'.$this->lang['modul_noitems'].'</strong>
							<p style="margin:5px"></p>
							<input type="button" title="'.$this->lang['button_cancel'].'" value="'.$this->lang['button_cancel'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />
						</li>';
		} else {
			$content .= '
						<li class="item">
							<input type="hidden" name="content_tstamp" value="'.$this->getActualTimeStamp().'" />
							<input type="hidden" name="content_sort" value="'.$this->getMaxSortVal().'" />
							<input type="hidden" name="content_type" value="3" />
								<div class="row_border">
									<div class="label_left">'.$this->lang['content_title'].' </div>
									<input type="text" id="content_title" name="content_title" value="" class="width_400" />
								</div>
							<p style="margin:5px"></p>
								<div class="row_border">
									<div class="label_left">'.$this->lang['content_subtitle'].'</div>
									<input type="text" name="content_subtitle" value=""class="width_400" />
								</div>
							<p style="margin:5px"></p>
								<div class="row_border">
									<div class="label_left">'.$this->lang['content_syskey'].'</div>
									<div class="label_left_200"><input type="text" name="content_syskey" value=""class="width_120" /></div>
									<div class="label_left">'.$this->lang['content_hidden'].' '.$this->contentCheckBox('hidden', '0').'</div>
									<div class="label_left_200">'.$this->lang['content_contenttype'].' '.$this->contenttypeDropDown('3').'</div>
								</div>
							<p style="margin:5px"></p>
								<div class="row_border">
									<div class="label_left">'.$this->lang['content_date'].'</div>
									<div class="label_left_200"><input type="text" id="content_starttime" name="content_starttime" value="'.$this->makeDate().'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_starttime').'</div>
									<div class="label_left">'.$this->lang['content_enddate'].'</div>
									<div class="label_left_200"><input type="text" id="content_endtime" name="content_endtime" value="'.$this->makeDate($this->makeTstamp(CN_TIMETOLIVE)).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_endtime').'</div>
								</div>
							<p style="margin:5px"></p>					
								<div class="row_noborder">
									<div class="label_left">'.$this->lang['content_insertmodul'].'</div>
									'.$cnModul->parseAllModulsSelect($this->allModulsArray).'
								</div>
						</li>
						<li class="item_footer">
							'.$this->makeCNAjaxLink($this->lang['button_save_and_edit'],'./library/function.newmodul.php?pid='.$this->pageid,'formeditcontentitem',$this->makePOSTLink(),'callback','','').'
							<input type="button" title="'.$this->lang['button_cancel'].'" value="'.$this->lang['button_cancel'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />
						</li>';
			$content .= $this->setJavaFocus('content_title');
		}
		return $content;
	}

	function getAlternativePagename($lang) {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "SELECT pagename_".$lang." FROM ".CN_TBL_SECTIONS." WHERE pageid = ".$this->pageid;
		$res= $cnDatabase->Execute($sql);
		$row= $res->FetchRow();
		return $row['pagename_'.$lang];
	}

	function getNewUser() {
		$content= '
				<form method="post" action="'.$this->makePOSTLink().'" name="useredit" id="useredit">
				<input type="hidden" name="user[mode]" value="content" />
				<input type="hidden" name="user[backendlanguage]" value="'.$this->lang['language_key'].'" />
				<input type="hidden" name="user[contentlanguage]" value="'.$this->contentLanguage.'" />
				<p class="head">'.$this->lang['user_label_user'].'</p>
					<ul>
						<li class="item">
						<div class="row_left_wide"><div class="label_left">'.$this->lang['user_name'].'</div><input type="text" class="pad_3" id="user_user" name="user[user]" value="" /></div>						
						<div class="row_left_wide"><div class="label_left">'.$this->lang['user_password'].'</div><input type="password" class="pad_3" name="user[password]" value="" /></div>												
						<div class="row_clear"></div>
						</li>
						<li class="item">
						<div class="row_left_wide"><div class="label_left">'.$this->lang['user_realname'].'</div><input type="text" class="pad_3" name="user[name]" value="" /></div>						
						<div class="row_left_wide"><div class="label_left">'.$this->lang['user_realemail'].'</div><input type="text" class="pad_3" name="user[email]" value="" /></div>												
						<div class="row_clear"></div>
						</li>
						<li class="item_noborder">
						<div class="row_right_clear">
							<input type="hidden" id="savenewuser" name="savenewuser" value="" />
							<input type="button" title="'.$this->lang['button_save'].'" value="'.$this->lang['button_save'].'" onclick="$(\'savenewuser\').value=1;this.form.submit();" class="submit_120" />
							<input type="button" title="'.$this->lang['button_cancel'].'" value="'.$this->lang['button_cancel'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />
						</div>
						</li>
					<ul>
				</form>';
		$content .= $this->setJavaFocus('user_user');

		return $content;
	}

	function getInfoUser($userid) {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "SELECT * FROM ".CN_TBL_SESSIONS." WHERE id = ".$userid;
		$res= $cnDatabase->Execute($sql);
		while ($row= $res->FetchRow()) {
			$this->userDataArray= $row;
		}
		$contentStart= '
					<form method="post" action="'.$this->makePOSTLink().'" name="useredit" id="useredit">
					<input type="hidden" name="user[userid]" value="'.$userid.'" />
					<p class="head">'.$this->lang['user_label_user'].'</p>
						<ul>';
		if ($this->userDataArray['group'] == 0) {
			$contentList= '<li class="item"><div class="row">Cannot edit admin ...</div></li>';
		} else {
			$contentList= '
						<li class="item">
							<div class="row_left_wide"><div class="label_left">'.$this->lang['user_name'].'</div><input type="text" class="pad_3" id="user_user" name="user[user]" value="'.$this->encodeStr($this->userDataArray['user']).'" /></div>						
							<div class="row_left_wide"><div class="label_left">'.$this->lang['user_password'].'</div><input type="text" class="pad_3" name="user[password]" value="'.$this->encodeStr($this->userDataArray['password']).'" disabled="true" /></div>												
							<div class="row_clear"></div>
						</li>
						<li class="item">
							<div class="row_left_wide"><div class="label_left">'.$this->lang['user_realname'].'</div><input type="text" class="pad_3" name="user[name]" value="'.$this->encodeStr($this->userDataArray['name']).'" /></div>						
							<div class="row_left_wide"><div class="label_left">'.$this->lang['user_realemail'].'</div><input type="text" class="pad_3" name="user[email]" value="'.$this->encodeStr($this->userDataArray['email']).'" /></div>												
							<div class="row_clear"></div>
						</li>
						<li class="item_noborder">
							<div class="row_right_clear">
								'.$this->makeCNAjaxLink($this->lang['button_save'],'./library/function.saveuser.php','useredit','','','user_'.$userid).'
								'.$this->makeCNAjaxLink($this->lang['button_save_close'],'./library/function.saveuser.php','useredit',$this->makePOSTLink(),'self').'
								<input type="button" title="'.$this->lang['button_cancel_close'].'" value="'.$this->lang['button_cancel_close'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />
							</div>
						</li>';
			$contentList .= $this->setJavaFocus('user_user');
		}
		$contentEnd= '</ul></form>';
		unset ($this->userDataArray);
		return $contentStart.$contentList.$contentEnd;
	}

	function getUserList() {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);	
		$sql= "SELECT * FROM ".CN_TBL_SESSIONS;
		$res= $cnDatabase->Execute($sql);
		while ($row= $res->FetchRow()) {
			$this->userArray[]= $row;
		}
		foreach ($this->userArray as $id => $value) {
			$parsedDate= ($value['timestamp'] == 0) ? '-' : date('Y-m-d H:i:s', $value['timestamp']);
			$groupName= ($value['group'] == 0) ? 'Admin' : 'User';
			$content .= '
						<li class="item">
						<div class="row">
						<div>';
			$content .= ($value['group'] == 0) ? '' : $this->makeCNImageLink(CN_SKINIMAGE.'tool_editfile.gif', $this->lang['user_edit'],$_SERVER['PHP_SELF'],'user',0,0,'_self','userid='.$value['id']);
			$content .= ($value['group'] == 0) ? '' : $this->makeCNImageLink(CN_SKINIMAGE.'tool_delete.gif', $this->lang['user_edit'],$_SERVER['PHP_SELF'],'user',0,0,'_self','deluserid='.$value['id'],'confirm');
			$content .= '<strong id="user_'.$value['id'].'" style="padding-left: 10px;">'.$this->encodeStr($value['user']).'</strong> | '.$this->lang['user_realname'].' <a href="mailto:'.$this->encodeStr($value['email']).'">'.$this->encodeStr($value['name']).'</a> | <small>('.$groupName.' | '.$this->lang['user_lastlogin'].' '.$parsedDate.')</small></div>
						</div>
						</li>';
		}
		unset ($this->userArray);
		return ''.$content.'</li>';
	}

	function getAllModuls() {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);	
		$sql= "SELECT * FROM ".CN_TBL_MODUL." WHERE deleted=0";
		$res= $cnDatabase->Execute($sql);
		while ($row= $res->FetchRow()) {
			$this->allModulsArray[]= $row;
		}
	}

	function getSingleModul($modulId) {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);	
		$sql= "SELECT * FROM ".CN_TBL_MODUL." WHERE id = ".$modulId." AND deleted=0";
		$res= $cnDatabase->Execute($sql);
		return $res->FetchRow();
	}

	function getSelectedModulParam($modulContentArray) {
		// get single modul array by id, explode first string |*|
		$getModulID= explode('|*|', $modulContentArray);
		// get modul config to $this->modulArray
		$modulArray = $this->getSingleModul($getModulID[0]);
		// return html elements
		$cnModul= new cnModul();
		return $cnModul->parseSelectedModulParam($modulArray, $modulContentArray,$this->lang);
	}

	function getMaxSortVal() {
		$array= cnEngine :: getMaxSort();
		return $array['maxsort'] + 1;
	}

	function getRootPageID() {
		$array= cnEngine :: getNavigationArray();
		return $array[1]['pageid'];
	}

	function getActualTimeStamp() {
		$now = adodb_getdate();
		return $now['0'];
	}

	function getPageTitle($pid) {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);	
		$sql= "SELECT pagename FROM ".CN_TBL_SECTIONS." WHERE pageid=".$pid." LIMIT 0, 30";
		$res= $cnDatabase->Execute($sql);
		$row = $res->FetchRow();
		return $this->encodeStr($row['pagename']);
	}

	function getBackendLanguage() {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);	
		$sql= "SELECT backendlanguage FROM ".CN_TBL_CONFIG." WHERE frontendlanguage = 'default';";
		$res= $cnDatabase->Execute($sql);
		$row = $res->FetchRow();
		return $row['backendlanguage'];
	}

	function getRichTextEdit($form) {
		$langGet= empty ($this->lang['language_key']) ? $this->getBackendLanguage() : $this->lang['language_key'];
		if (!empty ($form))
			return '
				<script language="javascript" type="text/javascript">
					initRichTextEditor(\''.$form.'\',\''.$langGet.'\',\''.CN_SKINDIR.'\');
				</script>';
	}

	function setSaveNewUser() {
		// only user allowed: group = 1
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);	
		$sql= "INSERT INTO ".CN_TBL_SESSIONS." (`user`, `password`, `name`, `email`, `group`, `mode`, `backendlanguage`, `contentlanguage`) VALUES (
										'".$this->decodeStr($_POST['user']['user'])."',
										'".md5($this->decodeStr($_POST['user']['password']))."',
										'".$this->decodeStr($_POST['user']['name'])."',
										'".$this->decodeStr($_POST['user']['email'])."',
										'1',
										'".$_POST['user']['mode']."',
										'".$_POST['user']['backendlanguage']."',
										'".$_POST['user']['contentlanguage']."'
									 )";
		$res= $cnDatabase->Execute($sql);
	}

	function setDeleteUser($userId) {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);	
		$sql= "DELETE FROM ".CN_TBL_SESSIONS." WHERE id=".$userId;
		$res= $cnDatabase->Execute($sql);
	}

	function setDeleteItem($deleteId) {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);		
		$sql= "UPDATE ".CN_TBL_CONTENT.$this->contentLanguageSuffix." SET deleted = '1' WHERE id=".$deleteId;
		$res= $cnDatabase->Execute($sql);
	}

	function setSavePage() {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);		
		$sql= 'SELECT * FROM '.CN_TBL_SECTIONS.' WHERE pageid = '.$this->pageid;
		$res= $cnDatabase->Execute($sql);
		// add $_POST['section'] vars to query
		foreach ($_POST['section'] as $id => $value) {
			$_POST['section'][$id] = $this->decodeStr($value);	
		}
		$sql= $cnDatabase->GetUpdateSQL($res, $_POST['section']);
		if (!empty ($sql)) {
			$res= $cnDatabase->Execute($sql);
		}
		// Move node ($contentnow->pageid) and its children to new parent ($_POST['target_section_id'])
		$tree = new tree();
		$tree->MoveAll($this->pageid, $_POST['target_section_id']);
	}
	
	function setDuplicatePage() {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);		
		$sql= 'SELECT * FROM '.CN_TBL_SECTIONS.' WHERE pageid = '.$this->pageid;
		$res= $cnDatabase->Execute($sql);
		
		// Insert Tree
		$tree= new tree();
		$parentInfo = $tree->GetParentInfo($this->pageid);
		$tree->Insert($parentInfo['pageid'], '', $_POST['section']);		
		$lastMySQLID= $cnDatabase->Insert_ID();
				
				
		$sqlLangconfig= "SELECT frontendlanguage FROM ".CN_TBL_CONFIG." WHERE frontendlanguage = 'default';";
		$resLangconfig= $cnDatabase->Execute($sqlLangconfig);
		$rowLangconfig = $resLangconfig->FetchRow();
		$explodeLangrow = cnEngine::getContentLanguage();
		
		foreach ($explodeLangrow as $lang) {
			if ($lang == 'default') { 
				$lang = '';
			} else {
				$lang = '_'.$lang;
			}
		
			$sql= 'SELECT * FROM '.CN_TBL_CONTENT.$lang.' WHERE pid = '.$this->pageid.' AND deleted = 0';
			$res= $cnDatabase->Execute($sql);
			$duplicatedContentArray = '';
			if ($res->RecordCount() > 0) {
				// Get items
				while ($row = $res->FetchRow()) {
					$sqlKey = '';
					$sqlValue = '';
					foreach ($row as $key => $value) {
						if ($key != 'id') {
							$sqlKey .= '`'.$key.'`,';
							// change pid to new site pageid
							if ($key == 'pid') {
								$sqlValue .= '\''.$lastMySQLID.'\',';
							} else {
								$sqlValue .= '\''.$value.'\',';
							}
						}
					}
					$sqlKey = ' ('.substr($sqlKey,0,-1).')';
					$sqlValue = ' VALUES ('.substr($sqlValue,0,-1).')';
					$duplicatedContentArray[] = 'INSERT INTO '.CN_TBL_CONTENT.$lang.$sqlKey.$sqlValue;
				}
				// Insert items
				foreach ($duplicatedContentArray as $sql) {
					$res= $cnDatabase->Execute($sql);
				}
			}
	}
	}	

	function setDeletePage() {
		// delete all content elements from page
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);			
		$sql= "UPDATE ".CN_TBL_CONTENT.$this->contentLanguageSuffix." SET deleted = '1' WHERE pid=".$this->pageid;
		$res= $cnDatabase->Execute($sql);
		// delete page from tree
		$tree= new tree();
		$tree->Delete($this->pageid);
	}

	function setMovePageUp($position) {
		if (!empty ($position)) {
			// Change node position and all its childrens to
			$tree= new tree();
			$tree->ChangePositionAll($this->pageid, $position, 'before');
		}
	}

	function setMovePageDown($position) {
		if (!empty ($position)) {
			// Change node position and all its childrens to
			$tree= new tree();
			$tree->ChangePositionAll($this->pageid, $position, 'after');
		}
	}

	function setSaveNewPage() {
		// Add new node
		$tree= new tree();
		$tree->Insert($_POST['new_target_section_id'], '', $_POST['section']);
	}

	function setDuplicateContentLanguage($lang='') {
		
		if (!empty($lang)) {
		
			$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
			$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);	

			// duplicate content
			$cn_content= CN_TBL_CONTENT;
			$cn_content_duplicate = $cn_content.'_'.$lang;
			$sql_content[]= "DROP TABLE IF EXISTS `$cn_content_duplicate`;";
			$sql_content[]= "CREATE TABLE IF NOT EXISTS `$cn_content_duplicate` (
							`id` int(11) NOT NULL auto_increment,
							`pid` int(11) NOT NULL default '',
							`sort` int(11) NOT NULL default '',
							`hidden` int(11) NOT NULL default '0',
							`tstamp` int(11) NOT NULL default '0',
							`starttime` int(11) NOT NULL default '0',
							`endtime` int(11) NOT NULL default '0',
							`deleted` int(11) NOT NULL default '0',
							`contenttype` int(11) NOT NULL default '0',
							`contentsyskey` varchar(255) NOT NULL default '',
							`contenttitle` varchar(255) NOT NULL default '',
							`contentsubtitle` varchar(255) NOT NULL default '',
							`contenturl` varchar(255) NOT NULL default '',
							`content` text NOT NULL,
							PRIMARY KEY  (`id`)
							) TYPE=MyISAM;";
			$sql_content[]= "INSERT INTO `$cn_content_duplicate` SELECT * FROM `$cn_content`;";
			foreach ($sql_content as $id => $value) {
				$res= $cnDatabase->Execute($value);
			}

			// new config item for new content language
			$sql_config= 'SELECT * FROM '.CN_TBL_CONFIG.' WHERE frontendlanguage = \'default\';';
			$res_config= $cnDatabase->Execute($sql_config);
			$row_config = $res_config->FetchRow();
			$sqlKey='';
			$sqlValue='';
			foreach ($row_config as $key => $value) {
					if ($key != 'id') {
						$sqlKey .= '`'.$key.'`,';
						// change frontendlanguage to new language
						if ($key == 'frontendlanguage') {
							$sqlValue .= '\''.$lang.'\',';
						} else {
							$sqlValue .= '\''.addslashes($value).'\',';
						}
					}
			}
			$sqlKey = ' ('.substr($sqlKey,0,-1).')';
			$sqlValue = ' VALUES ('.substr($sqlValue,0,-1).')';
			$sql_config = 'INSERT INTO '.CN_TBL_CONFIG.$sqlKey.$sqlValue;
			$res_config= $cnDatabase->Execute($sql_config);

			// duplicate alternative pagename: alter sections table
			$sql[]= "ALTER TABLE ".CN_TBL_SECTIONS." ADD `pagename_".$lang."` varchar(255) NOT NULL default ''";
			$sql_section= "SELECT pagename,pageid FROM ".CN_TBL_SECTIONS." WHERE pageid != 1";
			$res_section= $cnDatabase->Execute($sql_section);
			while ($row_section= $res_section->FetchRow()) {
				$sql[] = "UPDATE ".CN_TBL_SECTIONS." SET pagename_".$lang." = '".$row_section['pagename']."' WHERE pageid=".$row_section['pageid'];
			}
			foreach ($sql as $id => $value) {
				$res= $cnDatabase->Execute($value);
			}
			
		}
		
	}

	function setJavaFocus($focus= '') {
		if (!empty ($focus))
			return '<script type="text/javascript">window.onload = function(){$(\''.$focus.'\').focus();}</script>';
	}

	function makeUploadPopUp($path= '', $cid= '', $type= '', $single='') {
		$path= empty ($path) ? '?path=/no_path_configured' : '?path='.$path;
		$cid= empty ($cid) ? '' : '&cid='.$cid;
		$type= empty ($type) ? '' : '&type='.$type;
		$single= empty ($single) ? '' : '&single=true';
		return '<a href="#" onmouseover="window.status=\'contentnow\';return true;" onclick="SC_show(\''.$this->lang['label_filemanager'].'\', \'./upload.php'.$path.$cid.$type.$single.'\', 400, 800);this.blur();"><img src="'.CN_SKINIMAGE.'tool_link.gif'.'" border="0" alt=""></a>';
	}

	function makeToggleLink($div) {
		return '<a href="#" onmouseover="window.status=\'contentnow\';return true;" onclick="Effect.toggle(\''.$div.'\',\'slide\',\''.$div.'_img\'); this.blur(); return false;"><img src="'.CN_SKINIMAGE.'tool_plus.gif'.'" id="'.$div.'_img" border="0" alt=""></a>';
	}

	/**
	 * function makeCNAjaxLink()
	 *
	 * @descr	hmtl ouput link 
	 * @param	name, request_url, updated_div, class
	 * @return	string 
	 * @java 	function populateContentVars(updateUrl,formId,theUrl,targetSelf) 
	 * @example 	$this->makeCNAjaxLink('linkname','function.php','formname','callbackurl.php','self','updateDiv','className');
	 */
	function makeCNAjaxLink($name='', $updateUrl='', $formId='', $theUrl='', $targetSelf='', $updateDiv='', $class='' ) {
		
		$name= empty ($name) ? 'no_name_defined' : $name;		
		$updateDiv= empty ($updateDiv) ? '' : $updateDiv;
		$class= empty ($class) ? ' class="submit_120"' : ' class="'.$class.'"';
		
		if (empty($updateUrl) || empty ($formId)) {
			return 'Error generating Ajax Link ...';		
		} else {
			return '<input type="button" title="'.$name.'" value="'.$name.'" onclick="this.blur();populateContentVars(\''.$updateUrl.'\',\''.$formId.'\',\''.$theUrl.'\',\''.$targetSelf.'\',\''.$updateDiv.'\');"'.$class.' />';
		}
	}

	/**
	 * function makeCNAjaxImageLink()
	 *
	 * @descr	hmtl ouput link 
	 * @param	imageurl, request_url, updated_div, class
	 * @return	string 
	 * @java 	function populateContentVars(updateUrl,formId,theUrl,targetSelf) 
	 * @example 	$this->makeCNAjaxLink('imageurl','function.php','formname','index.php','self','myDiv','className');
	 */
	 
	function makeCNAjaxImageLink($imageurl='', $updateUrl='', $formId='', $theUrl='', $targetSelf='', $updateDiv='', $class='',$title='' ) {
		
		$title= empty ($title) ? 'contentnow' : $title;
		$name= empty ($name) ? 'no_name_defined' : $name;	
		$updateDiv= empty ($updateDiv) ? '' : $updateDiv;
		$class= empty ($class) ? '' : ' class="'.$class.'"';
		
		if (empty($updateUrl) || empty ($formId)) {
			return 'Error generating Ajax Link ...'.$updateUrl.$formId;		
		} else {
			return '<a href="#" title="'.$title.'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();populateContentVars(\''.$updateUrl.'\',\''.$formId.'\',\''.$theUrl.'\',\''.$targetSelf.'\',\''.$updateDiv.'\');"'.$class.'><img src="'.$imageurl.'" title="'.$title.'" alt="'.$title.'" border="0" /></a>';
		}
	}
	
	/**
	 * function makeCNAjaxNormalLink() NOT USED
	 *
	 * @descr	hmtl ouput link 
	 * @param	imageurl, request_url, updated_div, class
	 * @return	string 
	 * @java 	- 
	 * @example 	-
	 */
	 
	function makeCNAjaxNormalLink($name='', $updateUrl='', $updateDiv='', $class='', $successMsg='', $successDiv='' ) {
		
		$title= empty ($title) ? 'contentnow' : $title;
		$name= empty ($name) ? 'no_name_defined' : $name;
		$updateDiv= empty ($updateDiv) ? '' : $updateDiv;
		$class= empty ($class) ? '' : ' class="'.$class.'"';
		
		if (empty($updateUrl) ) {
			return 'Error generating Ajax Link ...'.$updateUrl;		
		} else {
			return '<a href="#" title="'.$title.'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();showContentVars(\''.$updateUrl.'\',\''.$updateDiv.'\');"'.$class.'>'.$name.'</a>';
		}
	}	

	/**
	 * function makeCNLink()
	 *
	 * @descr	hmtl ouput link 
	 * @param	name url mode pageid lang class target addUrlParam
	 * @return	string
	 * @example 	$this->makeCNLink('linkname',$_SERVER['PHP_SELF'],'mode','pageid','class_button','target','addParam');
	 */
	function makeCNLink($name= '', $url= '', $mode= '', $pageid= '', $class= '', $target= '', $addUrlParam= '') {
		$name= empty ($name) ? 'no_name_defined' : $name;
		$url= empty ($url) ? '#' : $url;
		$mode= empty ($mode) ? '?mode='.$this->mode : '?mode='.$mode;
		$pageid= empty ($pageid) ? '&pageid='.$this->pageid : '&pageid='.$pageid;
		$class= empty ($class) ? '' : ' class="'.$class.'"';
		$target= empty ($type) ? '_self' : $target;
		$addUrlParam= empty ($addUrlParam) ? '' : '&'.$addUrlParam;
		$langGet= empty ($this->lang['language_key']) ? '&lang='.$this->getBackendLanguage() : '&lang='.$this->lang['language_key'];
		$cLangGet= empty ($this->contentLanguage) ? '' : '&clang='.$this->contentLanguage;
		return '<a href="'.$url.$mode.$pageid.$langGet.$addUrlParam.$cLangGet.'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();" title="'.$name.'"'.$class.' target="'.$target.'">'.$name.'</a>';
	}
	
	function makeCNImageLink($imageurl='', $name= '', $url= '', $mode= '', $pageid= '', $class= '', $target= '', $addUrlParam= '', $addConfirm='') {
		$name= empty ($name) ? 'no_name_defined' : $name;
		$url= empty ($url) ? '#' : $url;
		$mode= empty ($mode) ? '?mode='.$this->mode : '?mode='.$mode;
		$pageid= empty ($pageid) ? '&pageid='.$this->pageid : '&pageid='.$pageid;
		$class= empty ($class) ? '' : ' class="'.$class.'"';
		$target= empty ($type) ? '_self' : $target;
		$addUrlParam= empty ($addUrlParam) ? '' : '&'.$addUrlParam;
		$langGet= empty ($this->lang['language_key']) ? '&lang='.$this->getBackendLanguage() : '&lang='.$this->lang['language_key'];
		$cLangGet= empty ($this->contentLanguage) ? '' : '&clang='.$this->contentLanguage;
		$addConfirm= empty ($addConfirm) ? '' : $this->confirmMsg();
		return '<a href="'.$url.$mode.$pageid.$langGet.$addUrlParam.$cLangGet.'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();'.$addConfirm.'" title="'.$name.'"'.$class.' target="'.$target.'"><img src="'.$imageurl.'" alt="'.$name.'" title="'.$name.'" border="0"></a>';
	}	

	function makeCNurl($url= '', $mode= '', $pageid= '',$addUrlParam= '') {
		$url= empty ($url) ? '#' : $url;
		$mode= empty ($mode) ? '?mode='.$this->mode : '?mode='.$mode;
		$pageid= empty ($pageid) ? '&pageid='.$this->pageid : '&pageid='.$pageid;
		$addUrlParam= empty ($addUrlParam) ? '' : '&'.$addUrlParam;
		$langGet= empty ($this->lang['language_key']) ? '&lang='.$this->getBackendLanguage() : '&lang='.$this->lang['language_key'];
		$cLangGet= empty ($this->contentLanguage) ? '' : '&clang='.$this->contentLanguage;
		return $url.$mode.$pageid.$langGet.$addUrlParam.$cLangGet;
	}
	
	function makeCNlanguageUrl($url= '',$addUrlParam= '') {
		$url= empty ($url) ? '#' : $url;
		$mode= empty ($mode) ? '?mode='.$this->mode : '?mode='.$mode;
		$pageid= empty ($pageid) ? '&pageid='.$this->pageid : '&pageid='.$pageid;
		$addUrlParam= empty ($addUrlParam) ? '' : '&'.$addUrlParam;
		$langGet= empty ($this->lang['language_key']) ? '&lang='.$this->getBackendLanguage() : '&lang='.$this->lang['language_key'];
		return $url.$mode.$pageid.$langGet.$addUrlParam;
	}	

	function makePOSTLink($mode= '',$overrideLanguage='') {
		$mode= empty ($mode) ? '?mode='.$this->mode : '?mode='.$mode;
		$pageid= empty ($this->pageid) ? '&pageid='.$this->getRootPageID() : '&pageid='.$this->pageid;
		$langGet= empty ($this->lang['language_key']) ? '&lang='.$this->getBackendLanguage() : '&lang='.$this->lang['language_key'];
		// override backend language
		$langGet= (!empty($overrideLanguage)) ? '' : $langGet;
		$cLangGet= empty ($_GET['clang']) ? '' : '&clang='.$_GET['clang'];
		return $_SERVER['PHP_SELF'].$mode.$pageid.$langGet.$cLangGet;
	}
	
	function makeTstamp($string) {
		// make tstamp
		list($date,$clock) = explode(' ',$string);
		list($mday,$mon,$year) = explode('.',$date);
		list($hours,$minutes) = explode(':',$clock);
		return adodb_mktime($hours,$minutes,0,$mon,$mday,$year);	
	}
	
	function makeDate($dateStr = '') {
		// make readable date
		$now = empty($dateStr) ? adodb_getdate() : adodb_getdate($dateStr);
		return sprintf('%02d',$now['mday']).'.'.sprintf('%02d',$now['mon']).'.'.$now['year'].' '.sprintf('%02d',$now['hours']).':'.sprintf('%02d',$now['minutes']);
	}

	function makeInputClear($identifier='',$value='') {
		if (!empty($identifier))
		return '&nbsp;<a href="#" onClick="this.blur();$(\''.$identifier.'\').value=\''.$value.'\';"><img src="'.CN_SKINIMAGE.'tool_minus.gif'.'" border="0" title="'.$this->lang['content_clear'].'" alt="'.$this->lang['content_clear'].'" /></a>';
	}
	
	function makeCalendarInput($identifier='') {
		if (!empty($identifier))
		return ' <img src="'.CN_SKINIMAGE.'tool_calendar.gif" id="trigger_calendar" style="cursor:pointer;" alt="'.$this->lang['content_calendar'].'" title="'.$this->lang['content_calendar'].'" />
				<script type="text/javascript">Calendar.setup({inputField:"'.$identifier.'",button:"trigger_calendar"});</script>';
	}	

	function makeAccesKeys() {
		$content= '
		<button accesskey="1" onclick="location.href=\''.$this->makePOSTLink('content').'\';">SiteContent</button>
		<button accesskey="2" onclick="location.href=\''.$this->makePOSTLink('meta').'\';">SiteMeta</button>
		<button accesskey="3" onclick="location.href=\''.$this->makePOSTLink('user').'\';">User</button>
		<button accesskey="4" onclick="location.href=\''.$this->makePOSTLink('config').'\';">Siteinfo</button>
		<button accesskey="5" onclick="location.href=\''.$this->makePOSTLink('modul').'\';">Module</button>
		<button accesskey="l" onclick="location.href=\'logout.php\';">LogOut</button>';
		return $content;
	}

	function contenttypeDropDown($input, $inputchange= '') {
		$onchange= ($inputchange == '') ? ' onchange="this.blur();populateContentVars(\'./library/function.saveitem.php\',\'formeditcontentitem\')"' : '';
			switch ($input) {
				case 'init':
					$out= '<select name="content[contenttype]" class="width_120"'.$onchange.'>
							<option value="0" selected>'.$this->lang['select_contenttype_content'].'
							<option value="1">'.$this->lang['select_contenttype_teaser'].'
							<option value="2">'.$this->lang['select_contenttype_dynamic'].'
							</select>';				
				break;
				case '0'  :
					$out= '<select name="content[contenttype]" class="width_120"'.$onchange.'>
							<option value="0" selected>'.$this->lang['select_contenttype_content'].'
							<option value="1">'.$this->lang['select_contenttype_teaser'].'
							</select>';
				break;
				case '1'  :
					$out= '<select name="content[contenttype]" class="width_120"'.$onchange.'>
							<option value="0" >'.$this->lang['select_contenttype_content'].'
							<option value="1" selected>'.$this->lang['select_contenttype_teaser'].'
							</select>';
				break;
				case '2'  :
					$out= $this->lang['select_contenttype_dynamic'];
				break;
				case '3'  :
					$out= $this->lang['select_contenttype_modul'];
				break;				
			}
		return $out;
	}

	function checkContentType($checkCtype) {
		switch ($checkCtype) {
			case '1' :
				return '_teaser';

			case '2' :
				return '_dynamic';

			case '3' :
				return '_modul';

			default :
				return '_text';
		}
	}

	function checkPageType($checkPtype) {
		switch ($checkPtype) {
			case '1' :
				return 'plugin/dtree/img/sys.gif';

			case '2' :
				return 'plugin/dtree/img/shortcut.gif';

			case '3' :
				return 'plugin/dtree/img/shortcut.gif';

			default :
				return '';
		}
	}

	/**
	 * function checkAccess()
	 * @descr	Check from config array if user have access
	 * @param	-
	 * @return	boolean		
	 */
	 
	function checkAccess($access) {
		if ($_SESSION["group"] == 0) return true;
		global $CN_GLOBAL;
		if ($CN_GLOBAL['access'][$access]) return true;
		return false;
	}

	function contentCheckBox($name, $input) {
		return ($input == 0) ? '<input type="hidden" name="'.$name.'" value="0"><input name="'.$name.'" type="checkbox" value="1" class="width_20" />' : '<input type="hidden" name="'.$name.'" value="0"><input name="'.$name.'" type="checkbox" value="1" checked="checked" class="width_20" />';
	}

	function searchDropDown($param= '') {

		switch ($param) {

			default :
				$out= '<select name="contentsearchnumber" class="width_120" onchange="this.form.submit();">
											<option value="10" selected>'.$this->lang['content_search10'].'
											<option value="20">'.$this->lang['content_search20'].'
											<option value="30">'.$this->lang['content_search30'].'
											<option value="all">'.$this->lang['content_searchall'].'
						</select>';
			break;

			case "20" :
				$out= '<select name="contentsearchnumber" class="width_120" onchange="this.form.submit();">
											<option value="10">'.$this->lang['content_search10'].'
											<option value="20" selected>'.$this->lang['content_search20'].'
											<option value="30">'.$this->lang['content_search30'].'
											<option value="all">'.$this->lang['content_searchall'].'
						</select>';
			break;

			case "30" :
				$out= '<select name="contentsearchnumber" class="width_120" onchange="this.form.submit();">
											<option value="10">'.$this->lang['content_search10'].'
											<option value="20">'.$this->lang['content_search20'].'
											<option value="30" selected>'.$this->lang['content_search30'].'
											<option value="all">'.$this->lang['content_searchall'].'
						</select>';
			break;

			case "all" :
				$out= '<select name="contentsearchnumber" class="width_120" onchange="this.form.submit();">
										<option value="10">'.$this->lang['content_search10'].'
										<option value="20">'.$this->lang['content_search20'].'
										<option value="30">'.$this->lang['content_search30'].'				
										<option value="all" selected>'.$this->lang['content_searchall'].'
						</select>';
			break;				
				
		}
		return $out;
	}

	function pagetypeDropDown($pagetype) {

		switch ($pagetype) {
			case "1" :
				$out= '<select name="section[pagetype]">
										<option value="0">'.$this->lang['select_page'].'
										<option value="1" selected>'.$this->lang['select_folder'].'
										<option value="2">'.$this->lang['select_urlextern'].'
										<option value="3">'.$this->lang['select_shortcut'].'</select>';
				break;

			case "2" :
				$out= '<select name="section[pagetype]">
										<option value="0">'.$this->lang['select_page'].'
										<option value="1">'.$this->lang['select_folder'].'
										<option value="2" selected>'.$this->lang['select_urlextern'].'
										<option value="3">'.$this->lang['select_shortcut'].'</select>';
				break;

			case "3" :
				$out= '<select name="section[pagetype]">
										<option value="0">'.$this->lang['select_page'].'
										<option value="1">'.$this->lang['select_folder'].'
										<option value="2">'.$this->lang['select_urlextern'].'	
										<option value="3" selected>'.$this->lang['select_shortcut'].'</select>';
				break;

			default :
				$out= '<select name="section[pagetype]">
										<option value="0" selected>'.$this->lang['select_page'].'
										<option value="1">'.$this->lang['select_folder'].'
										<option value="2">'.$this->lang['select_urlextern'].'		
										<option value="3">'.$this->lang['select_shortcut'].'</select>';
				break;
		}
		return $out;
	}

	function backendLanguageDropDown($formName, $selected='') {
		global $CN_GLOBAL;
		$select = '';
		foreach ($CN_GLOBAL['backend_language'] as $id => $value) {
				$_select = ($selected == $id) ? ' selected' : '';
				$select.= '<option value="'.$id.'"'.$_select.'>'.$value;
			}
		// manual creating Ajax Link
		return '<select name="'.$formName.'" id="backendlanguage" style="width:120px;" onchange="populateContentVars(\'./library/function.saveconfig.php\',\'formeditconfig\',\''.$_SERVER['PHP_SELF'].'?mode='.$this->mode.'&pageid='.$this->pageid.'&clang='.$_GET['clang'].'&lang=\'+$(\'backendlanguage\').value,\'self\',\'cn_pagemessage\');">'.$select.'</select>';
	}

	function frontendLanguageDropDown($formName, $selected='') {
		global $CN_GLOBAL;
		$select = '';
		foreach ($CN_GLOBAL['content_language'] as $id => $value) {
				$_select = ($selected == $id) ? ' selected' : '';
				$select.= '<option value="'.$id.'"'.$_select.'>'.$value;
			}
		return '<select name="'.$formName.'" style="width:120px;">'.$select.'</select>';
	}

	function contentLanguageDropDown($name,$selected='',$onlySelect=FALSE) {
		global $CN_GLOBAL;
		$out = '';
		$select = '';
		$langArray  = cnEngine::getContentLanguage();
		if (count($langArray) > 1) {
			foreach ($langArray as $value) {
				if ($value == 'default') {
					$_select = (empty($selected)) ? ' selected' : '';
					$select.= '<option value=""'.$_select.'>'.$value;
				} else {
					$_select = ($selected == $value) ? ' selected' : '';
					$select.= '<option value="'.$value.'"'.$_select.'>'.$CN_GLOBAL['content_language'][$value];
				}
			}
		$outSelect = '<select name="'.$name.'" style="width:120px;" onchange="document.location=\''.$this->makeCNlanguageUrl($_SERVER['PHP_SELF'], 'clang=').'\'+this.value">'.$select.'</select>';
		$out = '
		<p class="head">'.$this->lang['link_language'].'</p>
		<div style="padding: 5px;">'.$outSelect.'</div>';
		}
		if (!$onlySelect) {
			return $out; 
		} else {
			return $outSelect;
		}
	}

	function encodeStr($in) {
		return stripslashes($in);
	}
	
	function decodeStr($in) {
		return utf8_decode($in);
	}	

	function confirmMsg($msg='') {
		$msg = empty($msg) ? $this->lang['content_confirmdelete'] : $msg;
		return 'return confirm(\''.$msg.'\');';
	}

}