<?php

/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005/2006 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */

class cnEngine {

	var $pageid;
	var $contentLanguage;
	var $contentLanguageSuffix;

	var $configArray;
	var $contentArray;
	var $teaserContentArray;

	var $pageleft;
	var $pageright;
	var $pagelevel;
	var $pagename;
	var $pageimage;
	var $template;
	var $mtemplate;
	var $description;
	var $syskey;
	var $pagetype;
	var $pageurl;
	
	var $navigationArray;
	var $subNavigationArray;
	var $siteMapArray;
	var $clickPathArray;
	var $rootNodeID;
	var $rootNodeName;
	
	var $previewMode = false;

	function setId($id) {
		$this->pageid = $id;
	}
	
	function getId() {
		return $this->pageid;
	}	
	
	function setContentLanguage($setContentLanguage) {
		$this->contentLanguage = $setContentLanguage; 
		$this->contentLanguageSuffix = empty($setContentLanguage) ? '' : '_'.$setContentLanguage; 
	}	
	
	function getNavigationArray() {
		$tree = new tree();
		$tree->Full('');
		while ($item = $tree->NextRow()) {
			// get actual page informations
			// parse items to to actualPageArray	
			if ($item['pageid'] == $this->pageid) {
				$this->pageleft = $item['pageleft'];
				$this->pageright = $item['pageright'];
				$this->pagelevel = $item['pagelevel'];
				$this->pagename = $item['pagename'];
				$this->pageimage = $item['pageimage'];
				$this->template = $item['template'];
				$this->mtemplate = $item['mtemplate'];
				$this->description = $item['description'];
				$this->syskey = $item['syskey'];
				$this->pagetype = $item['pagetype'];
				$this->pageurl = $item['pageurl'];
				$this->actualPageArray = $item;
			}
			if ($this->contentLanguage != '' && $item['pageid'] != 1) {
				$item['pagename'] = $item['pagename'.$this->contentLanguageSuffix];
			}
			$item['pagename'] = stripslashes($item['pagename']);
			$navigationArray[] = $item;
			$siteMapArray[] = $item;
		}
		$this->navigationArray = $navigationArray;
		$this->siteMapArray = $siteMapArray;
		return $navigationArray;
	}

	function getSubNavigationArray() {
		$tree = new tree();
		$tree->Ajar($this->pageid, array ('pageid', 'pagelevel', 'pagename'));
		while ($item = $tree->NextRow()) {
			if ($item['pagelevel'] >= 2) {
				if ($this->contentLanguage != '')
					$item['pagename'] = $item['pagename'.$this->contentLanguageSuffix];
					$subNavigationArray[] = $item;
				}
				$item['pagename'] = stripslashes($item['pagename']);
		}
		$this->subNavigationArray = $subNavigationArray;
		return $subNavigationArray;
	}

	function getClickPathArray() {
		$tree = new tree();	
		$tree->Parents($this->pageid, array ('pageid', 'pagetype', 'pagename', 'pageurl'));
		while ($item = $tree->NextRow()) {
			if ($this->pageid <> $item['pageid']) {
				if ($item['pageid'] > 1) {
					if ($this->contentLanguage != '') {
						$item['pagename'] = $item['pagename'.$this->contentLanguageSuffix];
					}
					$item['pagename'] = stripslashes($item['pagename']);
				$clickPathArray[] = $item;
				}
			}
		}
		$clickPathArray[] = $this->actualPageArray;
		$this->clickPathArray = $clickPathArray;
		$this->rootNodeID = $clickPathArray[0]['pageid'];
		$this->rootNodeName = $clickPathArray[0]['pagename'];
		return $clickPathArray;
	}

	function getPageInfoArray($flag = '') {
		// no pid found and not deleted page
		if (count($this->actualPageArray) == 0 && empty ($flag)) die ('<span style="font:13px sans-serif;">Fatal Error! Page not configured. Please contact the webmaster.</span>');
		return $this->actualPageArray;
	}

	function getConfigPage() {
		$frontEndLanguage = empty($this->contentLanguage) ? 'default' : $this->contentLanguage;
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);	
		$sql = "SELECT ".TABLE_FIELDS_CONFIG." FROM ".CN_TBL_CONFIG." WHERE frontendlanguage='".$frontEndLanguage."'";
		$res = $cnDatabase->Execute($sql);
		if ($res->RecordCount() > 0) {
			while ($row = $res->FetchRow()) {
				$row['sitetitle'] = stripslashes($row['sitetitle']);
				$configArray[] = $row;
			}
		}
		$this->configArray = $configArray;
		return $configArray;
	}

	function checkPid($pid) {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql = "SELECT pageid FROM ".CN_TBL_SECTIONS." WHERE pageid = ".$pid;
		$res = $cnDatabase->Execute($sql);
		if ($res->RecordCount() > 0) {
			return true;
		} else {
			return false;	
		}
	}

	function getActualContent($param = '') {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);		
		$sql = "SELECT ".TABLE_FIELDS_CONTENT." FROM ".CN_TBL_CONTENT.$this->contentLanguageSuffix." WHERE pid = ".$this->pageid." AND deleted = 0 ".$param." ORDER by sort ASC";
		$res = $cnDatabase->Execute($sql);
		if ($res->RecordCount() > 0) {
			while ($row = $res->FetchRow()) {
				$row['contenttitle'] = stripslashes($row['contenttitle']);
				$row['contentsyskey'] = stripslashes($row['contentsyskey']);
				$row['contentsubtitle'] = stripslashes($row['contentsubtitle']);
				$contentArray[] = $row;
			}
		}
		$this->contentArray = $contentArray;
		return $contentArray;
	}

	function getSingleContent($cid,$param = '') {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);		
		$sql = "SELECT ".TABLE_FIELDS_CONTENT." FROM ".CN_TBL_CONTENT.$this->contentLanguageSuffix." WHERE id = ".$cid." AND deleted = 0 ".$param;
		$res = $cnDatabase->Execute($sql);
		if ($res->RecordCount() > 0) {
			while ($row = $res->FetchRow()) {
				$contentArray[] = $row;
			}
		}
		$this->contentArray = $contentArray;
		return $contentArray;
	}

	function getContentListMode($param = '') {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);		
		$sql = "SELECT ".TABLE_FIELDS_CONTENT." FROM ".CN_TBL_CONTENT.$this->contentLanguageSuffix." WHERE deleted = 0 ".$param;
		$res = $cnDatabase->Execute($sql);
		if ($res->RecordCount() > 0) {
			while ($row = $res->FetchRow()) {
				$contentArray[] = $row;
			}
		}
		$this->contentArray = $contentArray;
		return $contentArray;
	}

	function getMaxSort() {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);		
		$sql = "SELECT MAX(sort) as 'maxsort' FROM ".CN_TBL_CONTENT.$this->contentLanguageSuffix." WHERE deleted = 0 ";
		$res = $cnDatabase->Execute($sql);
		$row = $res->FetchRow();
		return $row;
	}	

	function getTeaserContent($param = '') {
		// only get teaser content if config teasercontentpageid is set
		if (!empty ($this->configArray[0]['teasercontentpageid'])) {
			// make where SQL Statement for multiple teaser pid
			$where = explode(',',$this->configArray[0]['teasercontentpageid']);
			$whereSql = ' WHERE ( ';
			foreach ($where as $value) {
				$whereSql .= ' pid = '.$value.' OR';
			}		
			$whereSql = substr($whereSql,0,-3).' ) ';
			// database connection
			$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
			$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);			
			$sql = "SELECT ".TABLE_FIELDS_CONTENT." FROM ".CN_TBL_CONTENT.$this->contentLanguageSuffix.$whereSql." AND deleted = 0 ".$param." ORDER by sort ASC";
			$res = $cnDatabase->Execute($sql);
			if ($res->RecordCount() > 0) {
				while ($row = $res->FetchRow()) {
					$row['contenttitle'] = stripslashes($row['contenttitle']);
					$row['contentsyskey'] = stripslashes($row['contentsyskey']);
					$row['contentsubtitle'] = stripslashes($row['contentsubtitle']);					
					$teaserContentArray[] = $row;
				}
				$this->teaserContentArray = $teaserContentArray;
			}
		}
		return $teaserContentArray;
	}

	function getTeaserPreviewContent($param = '') {
		// only get teaser content if config teasercontentpageid is set
		if (!empty ($this->configArray[0]['teasercontentpageid'])) {
			// make where SQL Statement for multiple teaser pid
			$where = explode(',',$this->configArray[0]['teasercontentpageid']);
			$whereSql = ' WHERE ( ';
			foreach ($where as $value) {
				$whereSql .= ' pid = '.$value.' OR';
			}		
			$whereSql = substr($whereSql,0,-3).' ) ';			
			// database connection
			$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
			$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);			
			$sql = "SELECT ".TABLE_FIELDS_CONTENT." FROM ".CN_TBL_CONTENT.$this->contentLanguageSuffix.$whereSql." AND deleted = 0 ".$param." ORDER by sort ASC";
			$res = $cnDatabase->Execute($sql);
			if ($res->RecordCount() > 0) {
				while ($row = $res->FetchRow()) {
					$row['content'] .= '<p><a href="#" onClick="window.opener.location=\''.CN_ROOT.CN_BASEDIR.'/index.php?action=edit&pageid='.$row['pid'].'&cid='.$row['id'].'\';window.opener.focus();"><img src=".'.CN_BASEDIR.'/'.CN_SKINIMAGE.'tool_editfile.gif" alt="edit" border="0"></a></p>';
					$teaserContentArray[] = $row;
				}
				$this->teaserContentArray = $teaserContentArray;
			}
		}
		return $teaserContentArray;
	}

	function getActualPreviewContent($param = '') {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);		
		$sql = "SELECT ".TABLE_FIELDS_CONTENT." FROM ".CN_TBL_CONTENT.$this->contentLanguageSuffix." WHERE pid = ".$this->pageid." AND deleted = 0 ".$param." ORDER by sort ASC";
		$res = $cnDatabase->Execute($sql);
		if ($res->RecordCount() > 0) {
			while ($row = $res->FetchRow()) {
				if ($row['contenttype'] != 3) {
					$row['content'] .= '<p><a href="#" onClick="window.opener.location=\''.CN_ROOT.CN_BASEDIR.'/index.php?action=edit&pageid='.$row['pid'].'&cid='.$row['id'].'\';window.opener.focus();"><img src=".'.CN_BASEDIR.'/'.CN_SKINIMAGE.'tool_editfile.gif" alt="edit" border="0"></a></p>';
				}
				if (strtotime("now") < $row['starttime'] || 1 == $row['hidden'] || strtotime("now") > $row['endtime']) $this->previewMode = true;
				$contentArray[] = $row;
			}
		}
		$this->contentArray = $contentArray;
		return $contentArray;
	}

	function parseTeaserContent() {
		// overide actual teaser
		$flag = 0;
		if (!empty ($this->contentArray)) {
			foreach ($this->contentArray as $value) {
				if ($value['contenttype'] == 1) {
					if ($flag == 0) {
						$flag = 1;
						unset ($this->teaserContentArray);
					}
					$this->teaserContentArray[] = $value;
				}
			}
		}
	}
	
	function getContentLanguage() {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "SELECT frontendlanguage FROM ".CN_TBL_CONFIG;
		$res = $cnDatabase->Execute($sql);
		if ($res->RecordCount() > 0) {
			while ($row = $res->FetchRow()) {
				$contentLanguage[] = $row['frontendlanguage'];
			}	
		}
		return $contentLanguage;
	}
	
	function checkContentLanguage($lang='') {
		$contentLanguage =$this->getContentLanguage();
		if (in_array($lang,$contentLanguage)) {
			return true;
		} else {
			return false;		
		}
	}	

	function cnGlobalUrlWrapper() {
		$getVar = $_GET;
		$wrapUrl = '';
		$wrapVar = array ('pageid','clang');
		foreach ($getVar as $key => $value) {
			if (in_array($key,$wrapVar)) $wrapUrl .= '&'.$key.'='.$value;
		}
		return $_SERVER['PHP_SELF'].'?'.substr($wrapUrl,1);
	}	
}