<?php

/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005/2006 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */

class cnModul {

	function getModulDir ($modulArray,$langArray) {
	
		$this->lang = $langArray;
		$setLang= $this->lang['language_key'];

		// get modul array
		$this->modulArray = $modulArray;
		$this->arrayKey = array();
				
		// join to one array
		if (is_array($this->modulArray)) {
			while (list($row, $item) = each ($this->modulArray)) {
				while (list($subRow,$subItem) = each ($item)) {
					$this->arrayKey[] = $subItem;
				}
			}
		}
		
		$content = '';
				
		// get modul dir in /cn
		$path = $_SERVER['DOCUMENT_ROOT'];
		if (substr($path, (strlen($path)-1)) == '/') $path = substr($path, 0, (strlen($path)-1));
		$this->absolutePath = $path.CN_MODUL_BASEDIR;
		
		// read directory
		if(is_dir($this->absolutePath)) {
			$dir = opendir($this->absolutePath);
			while(false !== ($file = readdir($dir))) {
				
					if ( (substr($file,0,1) != ".") && is_dir($this->absolutePath.$file) ) {
						
						// define standards
						$modulName = '';
						$modulAuthor = '';
						$modulVersion = '';
						$modulConf = '';
						$confirmInstallMsg = '';
						$confirmInstallMsgSuffix = '';
						
						// check for install already done or new install
						if (in_array($file,$this->arrayKey)) {
							
							// include param file							
							include ($this->absolutePath.$file.'/param.php');
							$key = array_search($file, $this->arrayKey);
							if ($this->arrayKey[$key+1] == $modulVersion) {							
								$installedMsg = $this->lang['modul_remove'];
								$linkParam = '&type=remove';
							} else {
								$installedMsg = $this->lang['modul_update'];
								$linkParam = '&type=update';								
							}
							$infoMsg = $this->lang['select_modulname'].' '.$this->arrayKey[$key-1].' <small>('.$this->lang['modul_version'].' '.$this->arrayKey[$key+1].')</small>';
						
						} else {

							// include param file
							include ($this->absolutePath.$file.'/param.php');
							$installedMsg = $this->lang['modul_install'];
							$linkParam = '&type=install';
							$modulName = (empty($modulName)) ? $file : $modulName;
							$infoMsg = $this->lang['select_modulname'].' '.$modulName.' <small>('.$this->lang['modul_version'].' '.$modulVersion.')</small>';
							
							// confirm install message, $modulConf defined in param.php
							if (is_array($modulConf)){
								if (in_array('db_install',$modulConf)) 
									$confirmInstallMsg = 'if(confirm(\''.$modulConf['modulInstallMsg'].'\')==true){';
									$confirmInstallMsgSuffix = '};"';
								}
						}				
					
                		$linkPreviewModul = '
					<input type="button" title="'.$installedMsg.'" value="'.$installedMsg.'" id="'.$file.'" onclick="'.$confirmInstallMsg.'this.disabled=\'true\';this.blur();showContentVars(\'./library/function.installmodul.php?path='.$file.'&lang='.$setLang.$linkParam.'\',\'modulstatus\',\''.$this->lang['modul_updated'].'\',\''.$file.'\');'.$confirmInstallMsgSuffix.'" class="submit_120">
					<input type="button" title="'.$this->lang['modul_info'].'" value="'.$this->lang['modul_info'].'" onclick="this.blur();showContentVars(\'./library/function.infomodul.php?path='.$file.'&lang='.$setLang.'\',\'modulstatus\');" class="submit_120">';
					$content .= '<li class="item">
									<div class="row_left_wide">'.$infoMsg.'</div>
									<div class="row_left_wide">'.$linkPreviewModul.'</div>
									<div class="row_clear"></div>
								</li>';
					} 
				}
			closedir($dir);
		}
		
		// if no files found, return no files msg 
		if (empty($content)) {
			$content .= '<li class="item">'.$this->lang['modul_noitems'].'</li>';
		}
		return '<ul>
					'.$content.'
				</ul>
				<p class="head_right">'.$this->lang['modul_status'].'</p>
				<ul>
					<li class="item">
						<div class="row"><div id="modulstatus">'.$this->lang['modul_status_message'].'</div></div>
					</li>
				</ul>';
	}
	
	function parseAllModulsSelect ($allModuls) {
			$content = '<select name="newmodulid">';
				foreach($allModuls as $value) {
					$content .= '<option value="'.$value['id'].'">'.$this->lang['select_modulname'].' '.$value['name'].'</option>';
				}
			$content .= '</select><p style="margin:5px"></p>';
		return $content;
	}	
		
	function parseSelectedModulParam ($singleModulArray, $modulContentArray,$langArray) {
		
		$this->lang = $langArray;
		$setLang= $this->lang['language_key'];
		
		// input type 'db', 'input', 'textarea', 'chooseFile', 'label', 'select'
		$_configArray = explode('|*|',$singleModulArray['config']);
		
		// name vars
		$_paramArray = explode('|*|',$singleModulArray['param']);
		
		// label vars
		$_labelArray = explode('|*|',$singleModulArray['label']);		
		
		// params from cn_content parsed from content: 0 -> modul_id | 1 -> modul_name | 2 -> modul_url | 3 -> params
 		$_contentParamArray = explode('|*|',$modulContentArray);
 		
		// paramsValue for $_contentParamArray
 		$_contentParamValueArray = explode('|*|',$singleModulArray['paramvalue']);
 		
		// modul standard params
		$modulId = $_contentParamArray[0];
		$modulName = $_contentParamArray[1];
		$modulUrl = $_contentParamArray[2];

		// define path
		$path = $_SERVER['DOCUMENT_ROOT'];	
		if (substr($path, (strlen($path)-1)) == '/') $path = substr($path, 0, (strlen($path)-1));
		$this->absolutePath = $path.CN_MODUL_BASEDIR;
		
		// get modul language file, check if language available
		$lang='';
		include ($this->absolutePath.$modulUrl.'/language.php');
		if (empty($lang[$setLang])) { 
			$setLang = 'en';
		} else {
			$setLang= $this->lang['language_key'];
		}
		
		$option = '';
		$content = '
		<input type="hidden" name="modul_url" value="'.$modulUrl.'">
		<input type="hidden" name="modul_id" value="'.$modulId.'">
		<input type="hidden" name="modul_name" value="'.$modulName.'">
		';
		
		// generate backend output
		foreach($_configArray as $id => $value) {
			
			switch ($value) {
				
				case 'db':

					// get modul dir in /cn
					$modulConf = '';
					include ($this->absolutePath.$modulUrl.'/param.php');

					// get param table Rows
					$_chooseTableRows = explode('|',$_contentParamValueArray[$id]);
					$_chooseDisplayRows = explode('|',$_paramArray[$id]);

					$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
					$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);	

					// delete entry
					if ($_GET['did']) {
						$sql = "DELETE FROM ".$modulConf['table_name']." WHERE id = ".$_GET['did'];
						$res = $cnDatabase->Execute($sql);						
					}		
					
					// delete entry
					if ($_GET['sid']) {
						$sql = "UPDATE ".$modulConf['table_name']." SET ";
						foreach($_chooseTableRows as $link_id) {
							if ($link_id != 'id') {
								$sql.= $link_id.'=\''.$_GET[$link_id].'\',';
							}
						}
						$sql = substr($sql,0,-1).' WHERE id='.$_GET['sid'];
						$res = $cnDatabase->Execute($sql);						
					}							
					
					// read mysql all entries
					$sql = "SELECT * FROM ".$modulConf['table_name']." ORDER by id";
					$res = $cnDatabase->Execute($sql);
					
					$content .= '
					<div class="row_noborder"><strong>'.$this->lang['modul_db'].' '.$modulName.'</strong></div>';					
					
					if ($res->RecordCount() > 0) {
						
						while ($row = $res->FetchRow()) {
							
							// url keeper
							$link = '';
							$linkArray= array('mode','pageid','lang','action','cid');

							foreach($_GET as $get_id => $get_value) {
								if ( in_array($get_id,$linkArray)) {
									$link.= '&'.$get_id.'='.$get_value;
								}
							}
						
						// edit mode
						
							if ($_GET['mid'] == $row['id']) {
								$content .= '<div class="row_noborder">';
								foreach($_chooseTableRows as $link_id) {
									if ($link_id != 'id') {
										$inputFields .= '<div class="label_left">'.$link_id.':</div> <input type="text" class="width_400" id="'.$link_id.'" value="'.$row[$link_id].'">
														<p style="clear:both;margin:5px;"></p>';
										$changeUrl.= '+\'&'.$link_id.'=\'+$(\''.$link_id.'\').value';
									}
								}
								$content .= '
								<form method="POST" action="'.$_SERVER['PHP_SELF'].'?sid='.$row['id'].'" id="moduleditdb" name="moduleditdb">
								'.$inputFields.'
								<input type="button" title="'.$this->lang['button_save'].'" value="'.$this->lang['button_save'].'" class="submit_120" 
								onclick="changeUrl(\''.$_SERVER['PHP_SELF'].'?sid='.$row['id'].$link.substr($changeUrl,2).')">
								</form>
								';
								
							} else {	
						
						// normal mode
						
								$linkUrl = '
								<a href="'.$_SERVER['PHP_SELF'].'?mid='.$row['id'].$link.'" onclick="changeUrl(\''.$_SERVER['PHP_SELF'].'?mid='.$row['id'].$link.'\')"><img src="'.CN_SKINIMAGE.'tool_editcontent.gif" border=""></a>							
								<a href="'.$_SERVER['PHP_SELF'].'?did='.$row['id'].$link.'" onclick="this.blur();return confirm(\'Delete?\');"><img src="'.CN_SKINIMAGE.'tool_delete.gif" border=""></a>';
								
								$content .= '<div class="row_noborder">'.$linkUrl;

								// standard ID
								$content .= '(ID '.$row['id'].') ';
								foreach($_chooseDisplayRows as $id) {
									if ($id != 'id') {
										// testing: $content .= '('.$id.') '.$row[$id].' ';
										$content .= substr(strip_tags($row[$id]),0,35).' | ';
									}
								}
								
								// delete trailing slash
								$content = substr($content,0,-2);
							}

							$content .= '</div>';
							
						}
						
					} else {
						
					// nothing found						
					$content .= '<div class="row_noborder">'.$this->lang['modul_no_entries'].'</div>';
					}
					
				break;
			
				case 'input':
					$content .= '
					<div class="row_border">
						<div class="label_left">'.$lang[$setLang][$_labelArray[$id]].': </div>
						<input type="text" name="modul_'.$_paramArray[$id].'" value="'.cnCore::encodeStr($_contentParamArray[$id+3]).'" class="width_400">
					</div>';
				break;
				
				
				case 'textarea':
					$content .= '
					<div class="row_noborder">
						<div class="label_left">'.$lang[$setLang][$_labelArray[$id]].': </div>
						<script language="javascript" type="text/javascript">
							initRichTextEditorSmall(\'modul_'.$_paramArray[$id].'\',\''.$setLang.'\',\''.CN_SKINDIR.'\');
						</script>
						<textarea name="modul_'.$_paramArray[$id].'" style="height:150px;width:470px;">'.$_contentParamArray[$id+3].'</textarea>
					</div>';
				break;

				case 'checkBox':
					$checkBox = ($_contentParamArray[$id+3] == 0) ? 
					'<input name="modul_'.$_paramArray[$id].'" type="checkbox" value="1" />' 
					: 
					'<input name="modul_'.$_paramArray[$id].'" type="checkbox" value="1" checked="checked" />';
					$content .= '
					<div class="row_border">
						<div class="label_left">'.$lang[$setLang][$_labelArray[$id]].': </div>
						'.$checkBox.'
					</div>';
				break;
				
				case 'label':
					$content .= '
					<div class="row_border">'.$lang[$setLang][$_labelArray[$id]].'</div>
					';
				break;
								
				case 'chooseFile':
    				$_chooseFileArray = explode('|',$_contentParamValueArray[$id]);
    				$_dirPath = $_chooseFileArray[0];
    				$_dirType = empty($_chooseFileArray[1]) ? 'file' : $_chooseFileArray[1];
    				$_getSingle = empty($_chooseFileArray[2]) ? '' : 'true';
    					
				    $linkPopUp = cnCore::makeUploadPopUp($_dirPath,'modul_'.$_paramArray[$id],$_dirType,$_getSingle);
					$content .= '
					<div class="row_border">
						<div class="label_left">'.$lang[$setLang][$_labelArray[$id]].': '.$linkPopUp.'</div>
						<input type="text" id="modul_'.$_paramArray[$id].'" name="modul_'.$_paramArray[$id].'" value="'.$_contentParamArray[$id+3].'" class="width_400">
					</div>';
				break;
				
				case 'chooseID':
					$_chooseIDArray = explode('|',$_contentParamValueArray[$id]);
					$_getSingle = empty($_chooseIDArray[0]) ? '' : 'true';
				    $linkPopUp = cnCore::makeUploadPopUp('','modul_'.$_paramArray[$id],'getID',$_getSingle);
					$content .= '
					<div class="row_border">
						<div class="label_left">'.$lang[$setLang][$_labelArray[$id]].': '.$linkPopUp.'</div>
						<input type="text" id="modul_'.$_paramArray[$id].'" name="modul_'.$_paramArray[$id].'" value="'.$_contentParamArray[$id+3].'" class="width_400">
					</div>';
				break;
				
				case 'functionFile':
					$_chooseFileArray = explode('|',$_contentParamValueArray[$id]);
					$_link = $_chooseFileArray[0];
					$_target = empty($_chooseFileArray[1]) ? '' : 'target="'.$_chooseFileArray[1].'"';
					$_param = empty($_chooseFileArray[2]) ? '' : 'onclick=\''.$_chooseFileArray[2].'\'';
					$content .= '
					<div class="row_border">
						<div class="label_left">'.$lang[$setLang][$_labelArray[$id]].'</div>
						<a href="'.$_link.'" '.$_target.' class="button" '.$_param.'>'.$this->lang['modul_function_file'].'<a>
					</div>';
				break;
				
				case 'select':
					// get select values
				    $_selectArray = explode('|',$_contentParamValueArray[$id]);
					foreach($_selectArray as $sid => $sValue) {
						if ($sValue == $_contentParamArray[$id+3]) {
							$option .= '<option value="'.$sValue.'" selected>'.$sValue.'</option>';
						} else {
							$option .= '<option value="'.$sValue.'">'.$sValue.'</option>';
						}
					}
					$content .= '
					<div class="row_border">
						<div class="label_left">'.$lang[$setLang][$_labelArray[$id]].': </div>
						<select name="modul_'.$_paramArray[$id].'" class="width_400">
						'.$option.'</select>
					</div>';
				break;
			}
		}
		return $content;
	}
}
?>