<?php

/**
 * Project: ContentNow | Small Content Management System
 * File: function.sortitem.php
 * Created: 01.03.2006
 *
 * Copyright (C) 2006 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */

	// get required classes
	require_once ('../adodb/adodb.inc.php');
	require_once ('./configure.php');	

	$contentLanguageSuffix = $_POST['contentLanguageSuffix'];
	$path = $_GET['path'];
	$setLang = $_GET['lang'];
	$type = $_GET['type'];

		include_once ('../language/'.$setLang.'.language.php');
		$clang= $cnLanguageArray[$setLang];


		// check for param file
		if (file_exists('../modul/'.$path.'/param.php')) {

			// include params
			$params= array ();
			$modulName= '';
			$modulVersion= '';
			$modulAuthor= '';
			$modulDescription= '';
			$modulUrl= '';
			$modulConf= '';
			
			include '../modul/'.$path.'/param.php';

			// parse array to sql syntax
			foreach ($params as $item) {
				$labelArray[]= $item[0];
				$configArray[]= $item[1];
				$paramArray[]= $item[2];
				$paramValueArray[]= $item[3];
			}

			// modulinfo
			$modulinfo= 'Name: '.$modulName.'<br>
						Version: '.$modulVersion.'<br>
						Author: '.$modulAuthor.'<br>
						Description: '.$modulDescription.'<br>
						';

			// switch type: remove, install, update
			switch ($type) {

				case "remove" :
					$modulinstallMsg= $modulinfo.$clang['modul_installremove'];
					
					$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
					$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
					
					$sql= "SELECT * FROM ".CN_TBL_MODUL." WHERE url=\"".$modulUrl."\" AND deleted=0";
					$res= $cnDatabase->Execute($sql);
					if ($res->RecordCount() == 1) {
						$sql= 'UPDATE '.CN_TBL_MODUL.' SET deleted=1 WHERE url="'.$modulUrl.'"';
						$res= $cnDatabase->Execute($sql);
						$modulinstallMsg .= $clang['modul_installfinised'];
					}
					break;

				case "install" :
					
					$modulinstallMsg= $modulinfo.$clang['modul_installinstall'];
					$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
					$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
					$sql= "SELECT * FROM ".CN_TBL_MODUL." WHERE url=\"".$modulUrl."\"";
					$res= $cnDatabase->Execute($sql);
					if ($res->RecordCount() == 1) {
						$sql= 'UPDATE '.CN_TBL_MODUL.' SET deleted=0 WHERE url="'.$modulUrl.'"';
					} else {
						if (!empty ($params)) {
							$sql= "INSERT INTO ".CN_TBL_MODUL." 
						(	name,
							url,
							version,
							author,
							config,
							param,
							label,
							paramvalue ) 
						VALUES 
						( '".$modulName."',
							'".$modulUrl."',
							'".$modulVersion."',
							'".$modulAuthor."',
							'".join('|*|', $configArray)."', 
							'".join('|*|', $paramArray)."', 					
							'".join('|*|', $labelArray)."',
							'".join('|*|', $paramValueArray)."' )";
						} else {
							$sql= "INSERT INTO ".CN_TBL_MODUL." 
						(	name,
							url,
							version,
							author ) 
						VALUES 
						(	'".$modulName."',
							'".$modulUrl."',
							'".$modulVersion."',
							'".$modulAuthor."' )";
						}
					}
					$res= $cnDatabase->Execute($sql);
					$modulinstallMsg .= $clang['modul_installfinised'];
					
					// check param file for additional database table
					if (is_array($modulConf)) {
						if (in_array('db_install',$modulConf)) {
	
							// get db param
							$table = $modulConf['table'];
						
							// install additional db
							foreach ($table as $id => $value) {
								$res = $cnDatabase->Execute($value);
								if ($res == false) die ("Modul table creation failed. Check your database configuration<br><br>".$value."<br><br>".mysql_error());
							}
	
							// add Modul Message						
							$modulinstallMsg.= ' | '.$clang['modul_installdb'];
						}
					}
					break;

				case "update" :
					$modulinstallMsg= $modulinfo.$clang['modul_installupdate'];
					$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
					$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);					
					$sql= "SELECT * FROM ".CN_TBL_MODUL." WHERE url=\"".$modulUrl."\" AND deleted=0";
					$res= $cnDatabase->Execute($sql);
					if ($res->RecordCount() == 1) {
						$sql= "UPDATE ".CN_TBL_MODUL." SET
								name='".$modulName."',	
								url='".$modulUrl."',
								version='".$modulVersion."',			
								author='".$modulAuthor."',						
								config='".join('|*|', $configArray)."',
								param='".join('|*|', $paramArray)."', 
								label='".join('|*|', $labelArray)."',
								paramvalue='".join('|*|', $paramValueArray)."',
								deleted=0			
								WHERE url='".$modulUrl."'";
						$res= $cnDatabase->Execute($sql);
						$modulinstallMsg .= $clang['modul_installfinised'];
					}
					break;

				default :
					$modulinstallMsg= $clang['modul_installerror'].' type error';
					break;
			}

		} else {
			// cant find param file
			$modulinstallMsg= $clang['modul_installerror'].' path error';
		}

	echo $modulinstallMsg;
	
?>