<?php
/**
*
* ContentNow | Small Content Management System
*
* Copyright (C) 2005 Andre Michaelis <kontakt@michaelis-freunde.de>
*
* This file may be distributed and/or modified under the terms of the
* "GNU General Public License" version 2 as published by the Free
* Software Foundation and appearing in the file LICENSE included in
* the packaging of this file.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
* THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
* PURPOSE.
*
* The "GNU General Public License" (GPL) is available at
* http://www.gnu.org/copyleft/gpl.html.
* 
*/
class cn_insert_image_gallery {

	function cn_insert_image_gallery ($smarty) {
		$this->smarty = $smarty;
	}
	
	function cn_init_insert_image_gallery ($obj) {
		$this->obj = $obj;
		$this->paramArray = explode('|*|',$this->obj['content']);
		
		// define basic params
		$this->modulID = $this->paramArray[0];
		$this->modulName = $this->paramArray[1];
		$this->modulUrl = $this->paramArray[2];
		
		// define individual params
		$this->image_gallery_path = CN_UPLOAD_BASEDIR.$this->paramArray[3];
		$this->image_gallery_org_path = $this->paramArray[3];
		$this->image_gallery_automatic_resize = $this->paramArray[4];
		$this->image_gallery_max_x=  empty($this->paramArray[5]) ? 200 : $this->paramArray[5];
		$this->image_gallery_max_y=  empty($this->paramArray[6]) ? 200 : $this->paramArray[6];
		// $this->paramArray[7] -> removeCache function
		$this->image_gallery_template = empty($this->paramArray[8]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_image_gallery.html' : $this->paramArray[8];
		
		// define language -> $lang
		$lang = array();
		$path = $_SERVER['DOCUMENT_ROOT'];	
		if (substr($path, (strlen($path)-1)) == '/') $path = substr($path, 0, (strlen($path)-1));
		include_once ($path.CN_MODUL_BASEDIR.$this->modulUrl.'/language.php');
		$this->modul_lang = $lang;
	}
	
	function cn_parse_insert_image_gallery() {
	
		// define path, delete ending '/'s
		$rootPath= $_SERVER['DOCUMENT_ROOT'];
		if (substr($rootPath, (strlen($rootPath) - 1)) == '/')
			$rootPath= substr($rootPath, 0, (strlen($rootPath) - 1));

		// define absolute path
		$absolute_path= $rootPath.$this->image_gallery_path;

		// read files to array
		if (is_dir($absolute_path)) {
			$fileArray = array();
			$dir= opendir($absolute_path);
			while ($file= readdir($dir)) {
				// check for ..-files
				if (substr($file, 0, 1) !== ".") {
					$typeArray = array('jpg','gif');
					// file found
					if (is_file($absolute_path.$file) == true && in_array(substr(strtolower($file),-3),$typeArray)) {
					$fileArray[] = $file;
					}
				}
			}
		}
		
		sort($fileArray);
		
	// display resized images
	
		$imageArray = array();
	
		if ($this->image_gallery_automatic_resize == 'yes' && false == empty($this->image_gallery_org_path)) {

			// get required classes
			if (file_exists($rootPath.CN_ROOT.CN_BASEDIR.'/library/class.thumbnail.php')) {
				require_once ($rootPath.CN_ROOT.CN_BASEDIR.'/library/class.thumbnail.php');
			} else {
				die ('Fatal error loading modul '.$this->modulName.'. Please contact the webmaster.');
			}

			// get current folder
			$getCurrentFolderArray = explode('/',$this->image_gallery_org_path);
			$getCurrentFolderCount = count($getCurrentFolderArray) - 2;
			$getCurrentFolder = $getCurrentFolderArray[$getCurrentFolderCount].'_thumb';		
	
			// define absolute temp path
			$absolute_temp_path= $rootPath.CN_UPLOAD_C_BASEDIR.$getCurrentFolder;	
	
			if (!is_dir($absolute_temp_path)) {
				$old_umask= umask(0);
				mkdir($absolute_temp_path, 0777);
				umask($old_umask);
			}
			
			foreach ($fileArray as $imgPath) {
				if (!file_exists($absolute_temp_path.'/'.$imgPath)) {
					$thumb= new Thumbnail($absolute_path.$imgPath, $this->image_gallery_max_x, $this->image_gallery_max_y, 100);
					$thumb->save($absolute_temp_path.'/'.$imgPath);				
				}
				$imageArray[$imgPath]['name'] = $imgPath;
				$imageArray[$imgPath]['url'] = CN_UPLOAD_C_BASEDIR.$getCurrentFolder.'/'.$imgPath;
				$imageArray[$imgPath]['link'] = $this->image_gallery_path.$imgPath;
			}
				
		} else {
		
	// display normal images
	
			foreach ($fileArray as $imgPath) {
				$imageArray[$imgPath]['name'] = $imgPath;
				$imageArray[$imgPath]['url'] = $this->image_gallery_path.$imgPath;
				$imageArray[$imgPath]['link'] = '';
			}
			
		}
		$this->smarty->assign('modulUrl',CN_MODUL_BASEDIR.$this->modulUrl);
		$this->smarty->assign('resize',$this->image_gallery_automatic_resize == 'yes' ? true : false);
		$this->smarty->assign('imageArray',$imageArray);
		return $this->smarty->fetch($this->image_gallery_template);
	}
	
}

?>