<?php
/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */

class cn_insert_sendtip {

	function cn_insert_sendtip ($smarty) {
		$this->smarty = $smarty;
	}
	
	function cn_init_insert_sendtip ($obj) {
		$this->obj = $obj;
		$this->paramArray = explode('|*|',$this->obj['content']);
		
		// define basic params
		$this->modulID = $this->paramArray[0];
		$this->modulName = $this->paramArray[1];
		$this->modulUrl = $this->paramArray[2];
		
		// define individual params
		$this->sendtip_sitename = $this->paramArray[3];
		$this->sendtip_siteurl = $this->paramArray[4];	
		$this->sendtip_error_backbutton = (empty($this->paramArray[5])) ? 'back' : $this->paramArray[5];
		$this->sendtip_error_text = (empty($this->paramArray[6])) ? 'error' : $this->paramArray[6];
		$this->sendtip_thankyou_text = (empty($this->paramArray[7])) ? 'thank you' : $this->paramArray[7];
		$this->sendtip_template = empty($this->paramArray[8]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_sendtip.html' : $this->paramArray[8];
		$this->sendtip_template_email = empty($this->paramArray[9]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_sendtip_email.html' : $this->paramArray[9];		
		
		// define language -> $lang
		$lang = array();
		$path = $_SERVER['DOCUMENT_ROOT'];	
		if (substr($path, (strlen($path)-1)) == '/') $path = substr($path, 0, (strlen($path)-1));
		include_once ($path.CN_MODUL_BASEDIR.$this->modulUrl.'/language.php');
		$this->modul_lang = $lang;
	}
	
	function input_check_mailinj($value) {
	
	   // mail adress(ess) for reports
	   $report_to = CN_WEBMASTER_EMAIL;
		
	   // array holding strings to check...
	   $suspicious_str = array
	   (
		   "content-type:",
		   "charset=",
		   "mime-version:",
		   "multipart/mixed",
		   "bcc:"
	   );
	
	   // remove added slashes from $value...
	   $value = stripslashes($value);
	
	   foreach($suspicious_str as $suspect) {
	   
	   
		   // checks if $value contains $suspect...
		   if(eregi($suspect, strtolower($value))) {
			   $ip = (empty($_SERVER['REMOTE_ADDR'])) ? 'empty' : $_SERVER['REMOTE_ADDR'];
			   $rf = (empty($_SERVER['HTTP_REFERER'])) ? 'empty' : $_SERVER['HTTP_REFERER'];
			   $ua = (empty($_SERVER['HTTP_USER_AGENT'])) ? 'empty' : $_SERVER['HTTP_USER_AGENT'];
			   $ru = (empty($_SERVER['REQUEST_URI'])) ? 'empty' : $_SERVER['REQUEST_URI'];
			   $rm = (empty($_SERVER['REQUEST_METHOD'])) ? 'empty' : $_SERVER['REQUEST_METHOD'];
			
			   // if so, file a report...
			   if(isset($report_to) && !empty($report_to)) {
				   @mail (
						 $report_to
					   ,"[ABUSE] mailinjection @ " . $_SERVER['HTTP_HOST'] . " by " . $ip
					   ,"Stopped possible mail-injection @ " . $_SERVER['HTTP_HOST'] . " by " . $ip . " (" . date('d/m/Y H:i:s') . ")\r\n\r\n" .
						 "*** IP/HOST\r\n" . $ip . "\r\n\r\n" .
						 "*** USER AGENT\r\n" . $ua . "\r\n\r\n" .
						 "*** REFERER\r\n" . $rf . "\r\n\r\n" .
						 "*** REQUEST URI\r\n" . $ru . "\r\n\r\n" .
						 "*** REQUEST METHOD\r\n" . $rm . "\r\n\r\n" .
						 "*** SUSPECT\r\n--\r\n" . $value . "\r\n--"
				   );
			   }
				
			   // ... and kill the script.
			   die (
				   'Script processing cancelled: string (`<em>'.$value.'</em>`) contains text portions that are ' .
				   'potentially harmful to this server. <em>Your input has not been sent!</em> Please use your ' .
				   'browser\'s `back`-button to return to the previous page and try refrasing your input.</p>'
			   );
		   }
	   }
	}
	
	function cn_parse_insert_sendtip() {
	
		if ($_POST['submit']) {
			
			// check security
			foreach ($_POST['tipform'] as $value) $this->input_check_mailinj($value);
		
			$EmailTo = $_POST['tipform']['recipient'];
			$EmailFrom = $_POST['tipform']['email'];
			$NameEmailFrom = $_POST['tipform']['name'];
			$EmailMessage = $_POST['tipform']['message'];
			
			$this->smarty->assign('EmailFrom', $NameEmailFrom);
			$this->smarty->assign('EmailMessage', $EmailMessage);
			$this->smarty->assign('Siteurl', $this->sendtip_siteurl);
			$this->smarty->assign('Sitename', $this->sendtip_sitename);
			
			$Content = $this->smarty->fetch($this->sendtip_template_email);
			
			if ($EmailTo != '' && $EmailFrom != '' && $NameEmailFrom != '' ) {

				$success = mail($EmailTo, "Send2Friend ".$this->sendtip_sitename, $Content, "From: $EmailFrom\n");
				
				if ($success == true) {
					$out = nl2br($this->sendtip_thankyou_text);
				} else {
					$out = 'Error! Please contact the Webmaster ...';
				}
		
			} else {
					$out = nl2br($this->sendtip_error_text).'<br>
					<a href="javascript:history.go(-1);">'.$this->sendtip_error_backbutton.'</a>';
			}
		
		} else {

		$this->smarty->assign('sendtip_formurl', $_SERVER['PHP_SELF'].'?pageid='.$_GET['pageid']);
		$this->smarty->assign('Siteurl', $this->sendtip_siteurl);
		$this->smarty->assign('Sitename', $this->sendtip_sitename);
		$out = $this->smarty->display($this->sendtip_template);

		}
		return $out;
	}
	
}

?>