<?php

/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005/2006 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */
	
	// get required classes
	if (file_exists('./require.php')) {
		require_once ('./require.php');
		require_once ('./library/class.thumbnail.php');
	} else {
		die ('Fatal error loading CMS. Please contact webmaster.');
	}
	
	// make object
	$cnCore = new cnCore();
	
	// get/set language
	$setLang= (empty ($_GET['lang'])) ? $cnCore->getBackendLanguage() : $_GET['lang'];
	
	// define language
	include_once ('./language/'.$setLang.'.language.php');
	$lang= $cnLanguageArray[$setLang];
	
	// get url params
	$getPath= empty ($_GET['path']) ? '' : $_GET['path'];
	$getIdentifier= empty ($_GET['cid']) ? '' : $_GET['cid'];
	$getType= empty ($_GET['type']) ? 'file' : $_GET['type'];
	$getSingle= empty ($_GET['single']) ? 'false' : $_GET['single'];
	$getFolder= empty ($_GET['folder']) ? '' : $_GET['folder'].'/';
	
	// define path, delete ending '/'s
	$rootPath= $_SERVER['DOCUMENT_ROOT'];
	if (substr($rootPath, (strlen($rootPath) - 1)) == '/')
		$rootPath= substr($rootPath, 0, (strlen($rootPath) - 1));
	
	// fix ending backslash in folder path
	if (substr($getFolder, (strlen($getFolder) - 1)) == '/')
		$getCorrectedFolder= substr($getFolder, 0, (strlen($getFolder) - 1));

	// define absolute path
	$absolute_path= $rootPath.$getPath.$getFolder;
	$absolute_temp_path= $rootPath.CN_UPLOAD_C_BASEDIR;	

	// only admin access
	session_start();
	$adminAccess = $_SESSION["group"] == 0 ? true : false;
	$isAdminFolder = substr($value,-6) == '_admin' ? true : false;	

	// function upload
	if ($_POST['upload']) {
		if (!$_FILES['file_0']['name']) {
			$errorMsg= $lang['upload_msg_chossefile'];
		} else {
			foreach ($_FILES as $field => $field_name) {
				if ($field_name['name']) {
					$handle= move_uploaded_file($_FILES[$field]['tmp_name'], $absolute_path.$_FILES[$field]['name']);
					chmod($absolute_path.$_FILES[$field]['name'], 0777);
					if (!$handle) {
						$errorMsg .= $lang['upload_msg_nofile'].$_FILES[$field]['name'].'<br>';
					} else {
						$errorMsg .= $lang['upload_msg_success'].$_FILES[$field]['name'].'<br>';
					}
				}
			}
		}
	}

	// function make dir
	if ($_POST['folder']) {
		if ($_POST['foldername'] != '') {
			$old_umask= umask(0);
			mkdir($absolute_path.$_POST['foldername'], 0777);
			umask($old_umask);
			$errorMsg .= $lang['upload_create_folder'];
		} else {
			$errorMsg.= $lang['upload_nofoldername'];	
		}
	}
	
	// function delete file
	if ($_GET['delfile'] != '') {
		if (is_file($absolute_path.$_GET['delfile'])) {
			$deleteFile = unlink($absolute_path.$_GET['delfile']);
			if (!$deleteFile) print_r('Error while deleting file. ('.$absolute_path.$_GET['delfile'].')');
		} 
	}
	
	switch ($getType) {
	
		case "getID" :
	
			// set headline label
			$label= $lang['upload_label_pages'];
	
			// get sitemap navigation
			$cnEngine= new cnEngine();
			$siteMapArray = $cnEngine->getNavigationArray();
			
			foreach ($siteMapArray as $keyID) {
				$content .= '
					<li class="item">
						<div class="row">';
				if ($keyID['pageid'] == CN_IDROOT) {
					$content .= '<strong>'.cnCore::encodeStr($keyID['pagename']).'</strong>';
				} else {
					$name_prefix = '';
					if ($keyID['pagetype'] == 1) $name_prefix = ' <small>'.$lang['select_folder'].'</small>';
					if ($keyID['pagetype'] == 2) $name_prefix = ' <small>'.$lang['select_urlextern'].'</small>';
					if ($keyID['pagetype'] == 3) $name_prefix = ' <small>'.$lang['select_shortcut'].'</small>';		
					$content .= '<a href="#" onClick="parent.changeParentValue(\''.$getIdentifier.'\',\''.$keyID['pageid'].'\',\''.$getSingle.'\');parent.SC_hide();" style="padding-left: '. ($keyID['pagelevel'] * 20).'px;">'.cnCore::encodeStr($keyID['pagename'].$name_prefix).'</a>';
				}
				$content .= '</div></li>';
			}
		break;
	
		default :
		
			// set headline label
			$label= $lang['upload_label_files'].substr($getPath.$getFolder,1);

			// known filetype
			$typeImageArray = array('jpg','gif');
			$typeTextArray = array('tml', 'htm','tpl','php','css','txt');
			$excludeTypeArray = array ('tmp','emp');

			$typeArray = array_merge($typeImageArray, $typeTextArray);
	
			// define previous folder path
			$folderBackLink= '';
			$folderBackLinkParam= '';
			$folderArray= explode('/', $getFolder);
			$folderCount= count($folderArray);
	
			if ($folderCount != 1) {
				// check folder array
				for ($i= 0; $i < $folderCount -2; $i ++) {
					$folderBackLinkParam .= $folderArray[$i].'/';
				}
				// delete ending backslash
				if (substr($folderBackLinkParam, (strlen($folderBackLinkParam) - 1)) == '/')
					$folderBackLinkParam= substr($folderBackLinkParam, 0, (strlen($folderBackLinkParam) - 1));
	
				// make backlink
				$folderBackLink= '
				<li class="itemfolderback">
					<div class="row"><a href="'.$_SERVER['PHP_SELF'].'?path='.$getPath.'&cid='.$getIdentifier.'&type='.$getType.'&folder='.$folderBackLinkParam.'&lang='.$setLang.'&single='.$getSingle.'">'.$lang['button_back'].'</a></div>
				</li>';
			}

			// read directory and collect data
			if (is_dir($absolute_path)) {
				$fileArray = array();
				$dir= opendir($absolute_path);
				while ($file= readdir($dir)) {
					// check for ..-files
					if (substr($file, 0, 1) !== ".") {

					// file found
						if(is_file($absolute_path.$file) == true) {
						// fetch some fata
						$filedata= stat($absolute_path.$file);
						$size= round(($filedata[7] / 1024)).' kb';
						$size= $size > 1024 ? round(($size / 1024), 2).' MB' : $size;
						$size= $size == 0 ? $filedata[7].' bytes' : $size;
							if (in_array(substr(strtolower($file),-3),$typeArray)) {
								if (in_array(substr(strtolower($file),-3),$typeImageArray)) $type = 'image';
								if (in_array(substr(strtolower($file),-3),$typeTextArray)) $type = 'text';
								$info= 'Name: '.$file.'<br />Type: '.$type.'<br />Path: '.substr($getPath,1).$getFolder.'<br />Size: '.$size.'<br />';	
								$fileArray[$file] = array('file'=>$file,'path'=>$getPath.$getFolder,'type'=>$type,'suffix'=>substr(strtolower($file),-3),'size'=>$size,'info'=>$info);
							} else {
								if (!in_array(substr(strtolower($file),-3),$excludeTypeArray)) {
									$type = 'default';
									$info= 'Name: '.$file.'<br />Type: unknown<br />Path: '.substr($getPath,1).$getFolder.'<br />Size: '.$size.'<br />';
									$fileArray[$file] = array('file'=>$file,'path'=>$getPath.$getFolder,'type'=>$type,'suffix'=>substr(strtolower($file),-3),'size'=>$size,'info'=>$info);
								}
							}
						}

					// folder found						
						if(is_dir($absolute_path.$file) == true) {	
								$dirArray[] = $file;
						}
					}
				}
			}
			
			$folderContent= '';

			if (!empty($dirArray)) {
				sort ($dirArray);
	
				// only admin access
				session_start();
				$adminAccess = $_SESSION["group"] == 0 ? true : false;

				foreach ($dirArray as $value) {
					
					// only _admin folder have admin access
					$isAdminFolder = substr($value,-6) == '_admin' ? true : false;
				
					if ($getType == 'dir') 
						$buttonDirOk = ' <a href="#" onclick="parent.changeParentValue(\''.$getIdentifier.'\',\''.$getFolder.$value.'/\',\''.$getSingle.'\');parent.SC_hide();"><img src="'.CN_SKINIMAGE.'tool_ok.gif" border="0"></a>';
					
					if ($adminAccess) {
						$folderContent .= '
								<li class="itemfolder">
									<div class="row">
										'.$buttonDirOk.'<a href="'.$_SERVER['PHP_SELF'].'?path='.$getPath.'&cid='.$getIdentifier.'&type='.$getType.'&folder='.$getFolder.$value.'&lang='.$setLang.'&single='.$getSingle.'">'.$value.'</a>
									</div>
								</li>';
					} else {
						if (!$isAdminFolder) {
						$folderContent .= '
								<li class="itemfolder">
									<div class="row">
										'.$buttonDirOk.'<a href="'.$_SERVER['PHP_SELF'].'?path='.$getPath.'&cid='.$getIdentifier.'&type='.$getType.'&folder='.$getFolder.$value.'&lang='.$setLang.'&single='.$getSingle.'">'.$value.'</a>
									</div>
								</li>';
						}
					}
				}
			}
			
			$fileContent= '';
			if (!empty($fileArray)) {			
				ksort ($fileArray);
				foreach ($fileArray as $value) {

					$buttonOk = ' <a href="#" onclick="this.blur();parent.changeParentValue(\''.$getIdentifier.'\',\''.$getFolder.$value['file'].'\',\''.$getSingle.'\');parent.SC_hide();"><img src="'.CN_SKINIMAGE.'tool_ok.gif" border="0"></a>';
					$buttonDelete = ' <a href="'.$_SERVER['PHP_SELF'].'?path='.$getPath.'&cid='.$getIdentifier.'&type='.$getType.'&folder='.$getCorrectedFolder.'&lang='.$setLang.'&delfile='.$value['file'].'&single='.$getSingle.'" onclick="this.blur();'.$cnCore->confirmMsg($lang['content_confirmdelete']).'"><img src="'.CN_SKINIMAGE.'tool_delete.gif" border="0"></a>';	
					
					switch ($value['type']) {
						default :
							$buttonEdit = '';
							$previewimage = '<img src="'.CN_SKINIMAGE.'preview_default.gif" alt="">';
						break;
						case 'image' :
							$imagesize= getimagesize($absolute_path.$value['file']);
							$value['info'].= 'Dimension: '.$imagesize[0].' x '.$imagesize[1].' px<br />';
							$thumb_filename= substr($value['file'], 0, -4).'_thumb'.substr($value['file'], -4);
							$thumbsize_x= 100;
							$thumbsize_y= 100;

							// define Buttons
							$calcWidth = ($imagesize[0] < 600) ? '' : ' width=600 ';
							$previewTooltip= 'onmouseout="hideToolTip();" onmouseover="showToolTip(event,\'<img src='.$value['path'].$value['file'].' '.$calcWidth.' border=0 alt= >\');return false;"';
							$buttonPreview= ' <a href="'.CN_ROOT.'/showImg.php?file='.$getPath.$getFolder.$value['file'].'" target="_blank" onclick="this.blur();" '.$previewTooltip.'><img src="'.CN_SKINIMAGE.'tool_preview.gif" border="0"></a>';
							$buttonEdit = ' <a href="./image.php?file='.$value['file'].'&folder='.$getFolder.'&path='.$getPath.'&cid='.$getIdentifier.'&lang='.$setLang.'&type='.$getType.'&single='.$getSingle.'"><img src="'.CN_SKINIMAGE.'tool_edit.gif" border="0"></a>';
							
							// check if thumbnail exists		
							if (!file_exists($absolute_temp_path.$thumb_filename)) {
							
								// original file is bigger than max size -> make thumbnail	
								if ($imagesize[0] > $thumbsize_x || $imagesize[1] > $thumbsize_y) {
									$thumb= new Thumbnail($absolute_path.$value['file'], $thumbsize_x, $thumbsize_y, 100);
									$thumb->save($absolute_temp_path.$thumb_filename);
									$thumb_path= '../upload_c/';
									$value['info'].= 'Actual preview is resized.<br />';
								} else {
									// original file is smaller than max size -> no thumbnail needed
									$thumb_filename= $value['file'];
									$thumb_path= $getPath.$getFolder;
									$buttonPreview= '';
								}
								
								// temp image exists					
							} else {
								$thumb_path= '../upload_c/';
								$value['info'].= 'Actual preview is resized.<br />';
							}
							$thumbimage= 'background:url('.$thumb_path.$thumb_filename.') no-repeat center center;';
							$previewimage = '<img src="'.CN_SKINIMAGE.'preview_image.gif" alt="">';
							
						break;
						case 'text' :
							$buttonEdit = ' <a href="./edit.php?file='.$value['file'].'&folder='.$getFolder.'&path='.$getPath.'&cid='.$getIdentifier.'&lang='.$setLang.'&type='.$getType.'&single='.$getSingle.'"><img src="'.CN_SKINIMAGE.'tool_editfile.gif" border="0"></a>';
							$thumbimage = '';
							$previewimage = '<img src="'.CN_SKINIMAGE.'preview_text.gif" alt="">';
						break;
					}
					
					$infoTooltip= 'onmouseout="hideToolTip();" onmouseover="showToolTip(event,\''.$value['info'].'\');return false;"';
					$infoButton = ' <a href="#" onclick="this.blur();" '.$infoTooltip.'><img src="'.CN_SKINIMAGE.'tool_info.gif" border="0"></a>';
		
					switch ($getType) {
						default :
							$editButton = $buttonOk.$buttonPreview.$buttonDelete.$infoButton.'<br />'.substr($value['file'],0,18).$infoText;
						break;
						case 'imageedit' :
							if ($thumbimage == '') $buttonOk = '';
							$editButton = $buttonOk.$buttonEdit.$buttonPreview.$buttonDelete.$infoButton.'<br />'.substr($value['file'],0,18).$infoText;
						break;
						case 'upload' :
							$editButton = $buttonEdit.$buttonPreview.$buttonDelete.$infoButton.'<br />'.substr($value['file'],0,18).$infoText;
						break;
						case 'dir' :
							$editButton = $buttonPreview.$infoButton.'<br />'.$file.$infoText;
						break;							
					}
	
					$fileContent .= '
					<div id="row_upload">
						<ul>
							<li style="background-color:#EEE;height:40px;width:100%;"><div style="padding:2px;">'.$editButton.'</div></li>
							<li><div style="height:120px;width:120px;'.$thumbimage.'">'.$previewimage.'</div></li>
						</ul>
					</div>
					';
			
				}
			}
	
			// if no files found, return no files
			if (empty ($fileContent) && !empty($getCorrectedFolder) ) {
				$fileContent= '<ul><li class="item"><div class="row">'.$lang['upload_msg_noentries'].'</div></li></ul>';
			} else {
				if (empty ($fileContent)) {
					$fileContent = '';
				} else {
					$fileContent= '<ul><li class="item">'.$fileContent.'<div class="row"></div></li></ul>';
				}
			}
		
			// Parse Folder and files
			if (!empty($folderBackLink)) $folderBackLink = '<ul>'.$folderBackLink.'</ul>';
			if (!empty($folderContent)) $folderContent = '<ul>'.$folderContent.'</ul>';
			$content= $folderBackLink.$folderContent.$fileContent.$imageContent;
	
			// create headline
			$errorMsg= empty($errorMsg) ? '' : '<p class="head_right">'.$lang['modul_installlabel'].'</p><ul><li class="item"><div class="row">'.$errorMsg.'</div></li></ul><p style="margin-top: 20px;"></p>';
	
			// check for admin access
			if ($adminAccess) {
				$setFolderCount = 0;
			} else {
				$setFolderCount = 1;
			}
	
			// check for output is allowed
			if ((true == ($folderCount > $setFolderCount) && true == ($getType == 'upload')) || true == ($getType == 'file')) 
			$content.= '
			<p style="margin-top: 20px;"></p>
			'.$errorMsg.'
			<p class="head_right">'.$lang['upload_label_upload'].'</p>
			<ul>
			<li class="item">
				<div class="row">
							<div class="row_left">
								<input type="file" id="fileUpload" name="fileUpload1" class="pad_3" value="" />
							</div>
							<div class="row_left">
								<input type="submit" name="upload" onClick="Element.show(\'cn_pagemessage\');" id="upload" class="submit_120" value="'.$lang['upload_button_upload'].'" />
							</div>
				</div>
				<p style="clear:both;"></p>
				<div class="row">
							<p style="margin-top:10px;"></p>
							<div id="filesList"></div>
							<script>
								var multi_selector = new MultiSelector( document.getElementById( \'filesList\' ), 10 );
								multi_selector.addElement( document.getElementById( \'fileUpload\' ) );
							</script>							
				</div>
			</li>
			</ul>
			<p class="head_right">'.$lang['upload_label_folder'].'</p>
			<ul>
			<li class="item">
				<div class="row">
							<div class="row_left">
								<input type="text" name="foldername" class="pad_3" id="foldername" value="" class="width_200" />
							</div>
							<div class="row_left">
								<input type="submit" name="folder" id="folder" class="submit_120" value="'.$lang['upload_button_folder'].'" />
							</div>
				</div>
				<p style="clear:both;"></p>
			</li>
			</ul>
			';
			break;
	}
	
	$displayObj= '
		<div id="cn_tooltip" style="position:absolute;display:none;background-color:#FFF;border:1px solid #999;padding:5px;"><span id="cn_tooltip_content"></span></div>
		<form action="'.$_SERVER['PHP_SELF'].'?path='.$getPath.'&cid='.$getIdentifier.'&type='.$getType.'&single='.$getSingle.'&folder='.$getCorrectedFolder.'&lang='.$setLang.'" method="post" enctype="multipart/form-data" name="cn_file">
		<p class="head_border">'.$label.'</p>
		'.$content.'
		</form>';
	
		// Init smarty
		$smarty= new Smarty();
		$smarty->template_dir= CN_SKINDIR;
		$smarty->compile_dir= 'smarty/templates_cn';
		$smarty->cache_dir= 'smarty/cache';
		$smarty->config_dir= 'smarty/configs';
		
		$smarty->assign('cnSkinDir', CN_SKINDIR);
		$smarty->assign('lang_LANG', $lang['local_key']);
		$smarty->assign('charset', $lang['local_charset']);		
		
		$smarty->assign('contentDisplay', $displayObj);
		$displayUpload= $smarty->fetch('_upload.html');
		$smarty->assign('content', $displayUpload);
		
		$smarty->display('_page_upload.html');
		
?>